-- Created By CoderX, Team Matrix (2006 Year)
-- GENERAL PUBLIC LICENSE V0.2
-- Game Continue by MasterMen in 2017
-- Attempt #2 (cuz first was deleted :/)
-- Start: 2.06.2017, 14:48 (Fist Screenshot ever)

red    = Color.new(255, 	0,		0)
blue   = Color.new(0, 	0,		255)
green  = Color.new(0, 	255, 	0)
black  = Color.new(0, 	0, 		0)
white  = Color.new(255,	255,	255)

purple = Color.new(91,	16,		50)

mState = "Game"
--"Game"
--"Menu"
--"Options"

Player1_Wood = 0
Player1_Food = 0
Player1_Gold = 0
Player1_Stone = 0
Player1_Color = ""
Player1_Nick = ""
ScreenCount = 0

MapColor = {
	Map1 = Color.new(0,0,0),
	Map2 = Color.new(0,0,0),
	Map3 = Color.new(0,0,0),
}

falsename = "null"

ScreenCFG = io.open("Game Resources/ScreenCount.cfg", "r")
ScreenCount = tonumber(ScreenCFG :read())
ScreenCFG:close()

MapChoiseCFG = io.open("Configuration/MapChoise.cfg", "r")
MapChoise = tonumber(MapChoiseCFG:read())
MapChoiseCFG:close()

function LoadWorld()
	
	MapPath = ""
	
	if MapChoise == 0 then
		MapPath = "Temp"
	end
	if MapChoise == 1 then
		MapPath = "Map 1"
	end
	if MapChoise == 2 then
		MapPath = "Map 2"
	end
	if MapChoise == 3 then
		MapPath = "Map 3"
	end
	
	NickCFG = io.open("Configuration/Nickname.cfg", "r")
	Player1_Nick = tostring(NickCFG:read())
	NickCFG:close()
	
	ThemeCFG = io.open("Configuration/"..MapPath.."/MapTheme.cfg", "r")
	MapType = tostring(ThemeCFG:read())
	ThemeCFG:close()
	
	ColorCFG = io.open("Configuration/"..MapPath.."/Color.cfg", "r")
	Player1_Color = tostring(ColorCFG:read())
	ColorCFG:close()
	
	-- Resources \/
	
	WoodCFG = io.open("Configuration/"..MapPath.."/Wood.cfg", "r")
	Player1_Wood = tonumber(WoodCFG :read())
	WoodCFG:close()
	
	FoodCFG = io.open("Configuration/"..MapPath.."/Food.cfg", "r")
	Player1_Food = tonumber(FoodCFG:read())
	FoodCFG:close()
	
	GoldCFG = io.open("Configuration/"..MapPath.."/Gold.cfg", "r")
	Player1_Gold = tonumber(GoldCFG:read())
	GoldCFG:close()
	
	StoneCFG = io.open("Configuration/"..MapPath.."/Stone.cfg", "r")
	Player1_Stone = tonumber(StoneCFG:read())
	StoneCFG:close()
end

LoadWorld()
MapType1 = MapType

ColorPath = ""
PLRColor = Color.new(255,255,25)

if Player1_Color == "Blue" then
	ColorPath = "Blue"
PLRColor = Color.new(0,0,255)
end

if Player1_Color == "Red" then
	ColorPath = "Red"
PLRColor = Color.new(255,0,0)
end

SaveIndex = 1

VillagerPics = {
Down = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."1.PNG"),
Right = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."2.PNG"),
Left = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."3.PNG"),
Up = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."1.PNG"), -- No (4)
UpLeft = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."13.PNG"), -- No (43)
UpRight = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."12.PNG"), -- No (42)
DownLeft = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."13.PNG"),
DownRight = Image.load("Game Resources/Units/Villager/Villager"..ColorPath.."12.PNG"),

Icon = Image.load("Game Resources/Icons/Units/VillagerMaleIcon.jpg")
}

MilitiaSprite = {
--[[
Down = Image.load("")
Right = Image.load("")
Left = Image.load("")
Up = Image.load("")
UpLeft = Image.load("")
UpRight = Image.load("")
DownLeft = Image.load("")
DownRight = Image.load("")
--]]
}

OptionsBG = Image.load("Game Resources/Backgrounds/OptionsBG.png")
PanelBG = Image.load("Game Resources/Backgrounds/PanelBG.png")
OnullO = Image.load("Game Resources/Units/Villager/Old/noll.png")
CrystalSprite = {
Crystal1 = Image.load("Game Resources/Resources/Minerals.png")
}

BerrySprite = {
	Berry1 = Image.load("Game Resources/Resources/Berry1.png"),
	Berry2 = Image.load("Game Resources/Resources/Berry2.png")
}
TreeSprite = {
	Tree1 = Image.load("Game Resources/Resources/Tree1.png")
}

IMG_Cursor = Image.load("Game Resources/Cursors/Cursor1.png")
IMG_Background = Image.load("Game Resources/Backgrounds/Grass1.jpg")
IMG_GamePanel1 = Image.load("Game Resources/StandartPanel.png")
IMG_GamePanel2 = Image.load("Game Resources/AlphaPanel.png")
IMG_TownCenter = Image.load("Game Resources/Buildings/Town Center/"..ColorPath.."/TownCenter.png")

IMG_MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/Grass_MiniMap.png") -- Grass
--IMG_MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/Snow_MiniMap.png") -- Snow

GameMenu = Image.load("Game Resources/Backgrounds/GameMenu.png")

MenuButton = {
EmptyButton = Image.load("Game Resources/Buttons/MenuButtons/EmptyButton.png")
--ResumeGame = Image.load("Game Resources/Buttons/MenuButtons/ResumeButtonOFF.png"),
--Options = Image.load("Game Resources/Buttons/MenuButtons/OptionsButtonOFF.png"),
--Controls = Image.load("Game Resources/Buttons/MenuButtons/ControlsButtonOFF.png"),
--Save = Image.load("Game Resources/Buttons/MenuButtons/SaveButtonOFF.png"),
--ExitSave = Image.load("Game Resources/Buttons/MenuButtons/SaveAndExitButtonOFF.png"),
--Exit = Image.load("Game Resources/Buttons/MenuButtons/ExitButtonOFF.png")
}

null = {}
null[1] = {Exists = false, X = -850, Y = 80}

CurButton = 1

CurButton_old = CurButton

ButtonColor = {
	ResumeGame = Color.new(0,0,0),
	Options = Color.new(0,0,0),
	Controls = Color.new(0,0,0),
	Save = Color.new(0,0,0),
	ExitSave = Color.new(0,0,0),
	Exit = Color.new(0,0,0)
}

BackX={0,0,-480,-480}
BackY={0,-272,0,-272}
Arial = Font.load("Font/Arial.TTF")
Arial:setPixelSizes(11,11)

ScrollSpeed = 5

Villager = {
{DefaultHP = 50, HP = 50, Attack = 3, Speed = 2, Wood = 0, Gold = 0, Stone = 0, Food = 0, Exists = true, Selected = true, Pop = 1, IMG = VillagerPics.Down, W = 25, H = 40, X = 0, Y = 0}
}
Villager[1] = {DefaultHP = 50, HP = 50, Attack = 3, Speed = 2, Wood = 0, Gold = 0, Stone = 0, Food = 0, Exists = true, Selected = true, Pop = 0, IMG = VillagerPics.Down, W = 25, H = 40, X = 0, Y = 0}
Villager[2] = {DefaultHP = 50, HP = 50, Attack = 3, Speed = 2, Wood = 0, Gold = 0, Stone = 0, Food = 0, Exists = true, Selected = false, Pop = 0, IMG = VillagerPics.Down, W = 25, H = 40, X = 0, Y = 0}
Villager[3] = {DefaultHP = 50, HP = 50, Attack = 3, Speed = 2, Wood = 0, Gold = 0, Stone = 0, Food = 0, Exists = false, Selected = false, Pop = 0, IMG = VillagerPics.Down, W = 25, H = 40, X = 0, Y = 0}
TownCenter = {}
TownCenter[1] = {DefaultHP = 2400, HP = 2400, Attack = 4, Builded = true, Selected = false, Population = 5, IMG = IMG_TownCenter, W = 156 , H = 90 , X = 0, Y = 0}
MineralTEST = {
{MaxGold = 1200, Gold = 1200, Exists = true, IMG = CrystalSprite.Crystal1, W = 69, H = 55, X = 0, Y = 0},
} 
Tree = {}
Tree[1] = { MaxWood = 450, Wood = 450, Exists = true, IMG = TreeSprite.Tree1, W = nil, H = nil, X = 0, Y = 0 }
Berry = {}
Berry[1] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
Berry[2] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
Berry[3] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
Berry[4] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
--Berry[5] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
--Berry[6] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
--Berry[7] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }
--Berry[8] = { MaxFood = 450, Food = 450, Exists = true, Selected = false, IMG = BerrySprite.Berry1, W = 43, H = 41, X = 0, Y = 0 }

--[[
bonkSound = Sound.load("bonk.wav",true)
if MySkills == Very Cool then
	CityDefense.gameCreate()
end
cfm = Sound.load("game/Cits.wav")
--]]

cursorX = 2
cursorY = 2
Villager[1].X = 2
Villager[1].Y = 2
coordX = 3
coordY = 3

--Player1_Wood = 0
--Player1_Food = 0
--Player1_Gold = 0
--Player1_Stone = 0
Player1_Pop = 0
Player1_Pop = Player1_Pop + Villager[1].Pop
Player1_MaxPop = TownCenter[1].Population
Player1_Civ = ""
-- MapType May Be:
---- Grass
---- Snow

WorldPopulation = 0
MaxVillagers = 2
MaxMilitia = 0
MaxTC = 1
BerriesOnMap = 2

-- 330, 197 MiniMap Place

MapTypeBool = true
VillagerPos1 = true
VillagerPos2 = true
VillagerPos3 = true

function PopulationCheck()
if Villager[1].Exists == true then
	Villager[1].Pop = 1
end
if Villager[2].Exists == true then
	Villager[2].Pop = 1
end
if Villager[3].Exists == true then
	Villager[3].Pop = 1
end
-- The Hidden One
--[[
if Villager[4].Exists == true then
	Villager[4].Pop = 1
end
if Villager[5].Exists == true then
	Villager[5].Pop = 1
end
--]]
end
	
-- Creating Functions



while true do
	if MapType == "Grass" and MapTypeBool == true then
		MapTypeBool = false
		IMG_MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/Grass_MiniMap.png")
		IMG_Background = Image.load("Game Resources/Backgrounds/Grass2.png")
	end
	
	if MapType == "Snow" and MapTypeBool == true then
		MapTypeBool = false
		IMG_MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/Snow_MiniMap.png")
		IMG_Background = Image.load("Game Resources/Backgrounds/Snow1.png")
	end
	
	if MapType == "Desert" and MapTypeBool == true then
		MapTypeBool = false
		IMG_MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/Desert_MiniMap.png")
		IMG_Background = Image.load("Game Resources/Backgrounds/Desert1.png")
	end
	
	-- Magic Words
	screen:clear()
	pad = Controls.read()
	
	for i = 1,4 do
		screen:blit(BackX[i], BackY[i], IMG_Background, true)
	end

--for i = 0,1 do
	if TownCenter[1].Builded == true then
		screen:blit(TownCenter[1].X + 200, TownCenter[1].Y + 150, TownCenter[1].IMG, true)
	end
--end
	if null[1].Exists == true then
		screen:blit(null[1].X, null[1].Y, OnullO)
	end
	--[[
	for i = 0, BerriesOnMap do
		i = i + 1
		--]]
		x = 40
		y = 50
		if Berry[1].Exists == true then
			screen:blit(Berry[1].X + x, Berry[1].Y + y, Berry[1].IMG, true)
		end
		x = 10
		y = 40
		if Berry[2].Exists == true then
			screen:blit(Berry[2].X + x, Berry[2].Y + y, Berry[2].IMG, true)
		end
		x = -30
		y = 50
		if Berry[3].Exists == true then
			screen:blit(Berry[3].X + x, Berry[3].Y + y, Berry[3].IMG, true)
		end
		--[[
		x = x + 20
		y = y + 30
	end --]]
	
	if Tree[1].Exists == true then
		screen:blit(Tree[1].X + 420, Tree[1].Y - 80, Tree[1].IMG)
	end
	
	for i = 0, MaxVillagers do
		i = i + 1
		if Villager[i].Exists == true then
			screen:blit(Villager[i].X - 13, Villager[i].Y - 10, Villager[i].IMG)
		end
	end
	if VillagerPos == true then
		VillagerPos1 = false
		Villager[1].X = 160
		Villager[1].Y = 120
	end

	PopulationCheck()
	screen:blit(0, 0,IMG_GamePanel1, true)
	
	screen:blit(338,200,IMG_MiniMap)
	screen:fontPrint(Arial,288,13,Player1_Pop.."/"..Player1_MaxPop,white)
	screen:fontPrint(Arial,27,13,Player1_Wood,white)
	screen:fontPrint(Arial,94,13,Player1_Food,white)
	screen:fontPrint(Arial,160,13,Player1_Gold,white)
	screen:fontPrint(Arial,220,13,Player1_Stone,white)
	screen:fontPrint(Arial,380,190,Player1_Nick.." (0/0)",PLRColor)
	screen:blit(cursorX, cursorY, IMG_Cursor)
	
	if Villager[1].Selected and Villager[2].Selected == false then
		screen:fontPrint(Arial,185,235,"Villager",black)
		screen:blit(140,215,VillagerPics.Icon)
	end

	if Villager[2].Selected == true and Villager[1].Selected == false then
		screen:fontPrint(Arial,185,235,"Villager",black)
		screen:blit(140,215,VillagerPics.Icon)
	end

	if Villager[1].Selected == true and Villager[2].Selected == true then
		screen:blit(140,215,VillagerPics.Icon)
		screen:blit(170,215,VillagerPics.Icon)
	end

	if TownCenter[1].Selected == true then
		screen:fontPrint(Arial,185,235,"Town Center",black)
	end

	if mState == "Save" then -----------------------------------------------------------------------------------------
		
		screen:blit(51,22,PanelBG)
		
		screen:fontPrint(Arial,210,50,"Save Menu",Black)
		screen:fontPrint(Arial,200,80,"Save as Map 1",MapColor.Map1)
		screen:fontPrint(Arial,200,100,"Save as Map 2",MapColor.Map2)
		screen:fontPrint(Arial,200,120,"Save as Map 3",MapColor.Map3)
		
		if SaveIndex == 1 then
			MapColor.Map1 = Color.new(255,255,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 2 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(255,255,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 3 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(255,255,0)
		end
		
		if SaveIndex >= 4 then SaveIndex = 3 end
		if SaveIndex <= 0 then SaveIndex = 1 end
		
		if pad:down() then SaveIndex = SaveIndex + 1 end
		if pad:up() then SaveIndex = SaveIndex - 1 end
		
		if pad:cross() then
			if SaveIndex == 1 then
				MapChoise = 1
				LoadWorld()
			end
			if SaveIndex == 2 then
				MapChoise = 2
				LoadWorld()
			end
			if SaveIndex == 3 then
				MapChoise = 3
				LoadWorld()
			end
			
		end
		
		if pad:circle() then
			if pressed.circle == false then
			pressed.circle = true
			mState = "Menu"
			end
		else
			pressed.circle = false
		end
		
	end -----------------------------------------------------------------------------------------
	
	if mState == "Options" then -----------------------------------------------------------------------------------------
		
		screen:blit(51,22,OptionsBG)

		if pad:circle() then
			if pressed.circle == false then
			pressed.circle = true
			mState = "Menu"
			end
		else
			pressed.circle = false
		end
		
	end -- mState Options -----------------------------------------------------------------------------------------
	
	if mState == "Menu" then
		screen:blit(136,7,GameMenu)
		screen:fontPrint(Arial,203,32,"Game Paused",black)
		
		
		-- Menu Parts Blit
		screen:blit(160,42,MenuButton.EmptyButton) -- Resume Game
		screen:fontPrint(Arial,202,58,"Resume Game",ButtonColor.ResumeGame)
		
		screen:blit(160,74,MenuButton.EmptyButton) -- Options
		screen:fontPrint(Arial,218,90,"Options",ButtonColor.Options)
		
		screen:blit(160,106,MenuButton.EmptyButton) -- Controls
		screen:fontPrint(Arial,216,122,"Controls",ButtonColor.Controls)
		
		screen:blit(160,138,MenuButton.EmptyButton) -- Save
		screen:fontPrint(Arial,226,152,"Save",ButtonColor.Save)
		
		screen:blit(160,170,MenuButton.EmptyButton) -- Exit and Save
		screen:fontPrint(Arial,202,186,"Exit And Save",ButtonColor.ExitSave)
		
		screen:blit(160,203,MenuButton.EmptyButton) -- Exit
		screen:fontPrint(Arial,227,220,"Exit",ButtonColor.Exit)
		
		-- Moving
		if pad:down() then
			if pressed.down == false then
				pressed.down = true
				CurButton = CurButton + 1
			end
		else
			pressed.down = false
		end
		
		if pad:up() then
			if pressed.up == false then
				pressed.up = true
				CurButton = CurButton - 1
			end
		else
			pressed.up = false
		end
		
		if pad:cross() and CurButton == 1 then mState = "Game" end if pad:start() then mState = "Game" end -- Resume Game
		if pad:cross() and CurButton == 2 then mState = "Options" end -- Options
		if pad:cross() and CurButton == 3 then  end -- Controls
		if pad:cross() and CurButton == 4 then mState = "Save" end -- Save
		if pad:cross() and CurButton == 5 then  end -- Exit and Save
		if pad:cross() and CurButton == 6 then dofile("MainMenu.lua") end -- Exit
		
		if CurButton >= 7 then CurButton = 6 end
		if CurButton <= 0 then CurButton = 1 end
		
		-- Some Graphics (Annoying Part :D)
		if CurButton == 1 then
			ButtonColor.ResumeGame = Color.new(255,255,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 2 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(255,255,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 3 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(255,255,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 4 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(255,255,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 5 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(255,255,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 6 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(255,255,0)
		end

	end
	
	if mState == "Game" then ---------------------------------------------------------------------------------------------------------

		--ANALOG-X
		dx = pad:analogX()
		if math.abs(dx) > 32 then
			cursorX = cursorX + dx / 20
		end
		--ANALOG-Y
		dy = pad:analogY()
		if math.abs(dy) > 32 then
			cursorY = cursorY + dy / 20
		end
		--DPAD
		
		-- Moving all items --
		
		-- Y + -------------------------------------------------
		if pad:square() and pad:up() then
		for i = 1,4 do
			BackY[i] = BackY[i] + ScrollSpeed
		end
		TownCenter[1].Y = TownCenter[1].Y + ScrollSpeed
		MineralTEST[1].Y = MineralTEST[1].Y + ScrollSpeed
		Villager[1].Y = Villager[1].Y + ScrollSpeed
		Villager[2].Y = Villager[2].Y + ScrollSpeed
		Villager[3].Y = Villager[3].Y + ScrollSpeed
		--[[
		for i = 0, BerriesOnMap do
			i = i + 1
			Berry[i].Y = Berry[i].Y + ScrollSpeed
		end
		--]]
		null[1].Y = null[1].Y + ScrollSpeed
		Berry[1].Y = Berry[1].Y + ScrollSpeed
		Berry[2].Y = Berry[2].Y + ScrollSpeed
		Berry[3].Y = Berry[3].Y + ScrollSpeed
		Berry[4].Y = Berry[4].Y + ScrollSpeed
		Tree[1].Y = Tree[1].Y + ScrollSpeed
		coordY = coordY + ScrollSpeed
		end
		
		-- Y - --------------------------------------------------
		if pad:square() and pad:down() then
		for i = 1,4 do
			BackY[i] = BackY[i] - ScrollSpeed
		end
		TownCenter[1].Y = TownCenter[1].Y - ScrollSpeed
		MineralTEST[1].Y = MineralTEST[1].Y - ScrollSpeed
		Villager[1].Y = Villager[1].Y - ScrollSpeed
		Villager[2].Y = Villager[2].Y - ScrollSpeed
		Villager[3].Y = Villager[3].Y - ScrollSpeed
		--[[
		for i = 0, BerriesOnMap do
			i = i + 1
			Berry[i].Y = Berry[i].Y - ScrollSpeed
		end
		--]]
		null[1].Y = null[1].Y - ScrollSpeed
		Berry[1].Y = Berry[1].Y - ScrollSpeed
		Berry[2].Y = Berry[2].Y - ScrollSpeed
		Berry[3].Y = Berry[3].Y - ScrollSpeed
		Berry[4].Y = Berry[4].Y - ScrollSpeed
		Tree[1].Y = Tree[1].Y - ScrollSpeed
		coordY = coordY - ScrollSpeed
		end
		 
		-- X + -----------------------------------------------------
		if pad:square() and pad:left() then
		for i = 1,4 do
			BackX[i] = BackX[i] + ScrollSpeed
		end
		TownCenter[1].X = TownCenter[1].X + ScrollSpeed
		MineralTEST[1].X = MineralTEST[1].X + ScrollSpeed
		Villager[1].X = Villager[1].X + ScrollSpeed
		Villager[2].X = Villager[2].X + ScrollSpeed
		Villager[3].X = Villager[3].X + ScrollSpeed
		--[[
		for i = 0, BerriesOnMap do
			i = i + 1
			Berry[i].Y = Berry[i].X + ScrollSpeed
		end
		--]]
		null[1].X = null[1].X + ScrollSpeed
		Berry[1].X = Berry[1].X + ScrollSpeed
		Berry[2].X = Berry[2].X + ScrollSpeed
		Berry[3].X = Berry[3].X + ScrollSpeed
		Berry[4].X = Berry[4].X + ScrollSpeed
		Tree[1].X = Tree[1].X + ScrollSpeed
		coordX = coordX + ScrollSpeed
		end
		
		-- X - -------------------------------------------------------
		if pad:square() and pad:right() then
		for i = 1,4 do
			BackX[i] = BackX[i] - ScrollSpeed
		end
		TownCenter[1].X = TownCenter[1].X - ScrollSpeed
		MineralTEST[1].X = MineralTEST[1].X - ScrollSpeed
		Villager[1].X = Villager[1].X - ScrollSpeed
		Villager[2].X = Villager[2].X - ScrollSpeed
		Villager[3].X = Villager[3].X - ScrollSpeed
		--[[
		for i = 0, BerriesOnMap do
			i = i + 1
			Berry[i].Y = Berry[i].X - ScrollSpeed
		end
		--]]
		null[1].X = null[1].X - ScrollSpeed
		Berry[1].X = Berry[1].X - ScrollSpeed
		Berry[2].X = Berry[2].X - ScrollSpeed
		Berry[3].X = Berry[3].X - ScrollSpeed
		Berry[4].X = Berry[4].X - ScrollSpeed
		Tree[1].X = Tree[1].X - ScrollSpeed
		coordX = coordX - ScrollSpeed
		end
	
	

--[[
--for i = 0, 1 do
--i = i + 1
if cursorX >= TownCenter[1].X and cursorX <= cursorX + TownCenter[1].W and cursorY >= TownCenter[1].Y and cursorY <= cursorY + TownCenter[1].H and pad:cross() then
TownCenter[1].Selected = true
Villager[1].Selected = false
Villager[2].Selected = false
end
--end
--]]

		for i = 0, MaxVillagers do
			i = i + 1
			if cursorX >= Villager[i].X and cursorX <= cursorX + Villager[i].W and cursorY >= Villager[i].Y and cursorY <= cursorY + Villager[i].H and pad:cross() then
				if pressed.cross == true then
					pressed.cross = false
					Villager[i].Selected = true
				end
			else
				pressed.cross = true
			end
		end
		for i = 0, MaxVillagers do
			i = i + 1
			if pad:circle() then
				Villager[i].Selected = false
			end
		end
--for i = 0, 1 do
 --i = i + 1
 if pad:circle() then
  TownCenter[1].Selected = false
 end
--end

--[[
if start >= 1 then
bonkSound:play()
Music.volume(20)
start = 0
end
--]]

-- Control Background motion

	for i = 1,4 do
		if BackY[i] >= 272 then
			BackY[i] = -272
		end
		if BackX[i] > 480 then
			BackX[i] = -480 
		end
		if BackY[i] <= -273 then
			BackY[i] = 272
		end
		if BackX[i] < -480 then
			BackX[i] = 480 
		end
	end


--

--boundaries
	if cursorX >= 480 then
		cursorX = 480
	end

	if cursorX <= 0 then
		cursorX = 0
	end
	
	if cursorY <= 0 then
		cursorY = 0
	end

	if cursorY >= 252 then
		cursorY = 252
	end

	if pad:cross() then
	--if cursorX >= Villager[i].X and cursorX <= cursorX + Villager[i].W and cursorY >= Villager[i].Y and cursorY <= cursorY + Villager[i].H and NOTBool == true then
		coordX = cursorX
		coordY = cursorY
	--end
	end
	
	
	
	for i = 0, MaxVillagers do
		i = i + 1
		if Villager[i].Selected == true then
		
			if coordX >= Villager[i].X then
				Villager[i].X = Villager[i].X + Villager[i].Speed
				--cfm:play()
			end
			if coordX <= Villager[i].X then
				Villager[i].X = Villager[i].X - Villager[i].Speed
				--cfm:play()
			end
			if coordY >= Villager[i].Y then
				Villager[i].Y = Villager[i].Y + Villager[i].Speed
				--cfm:play()
			end
			if coordY <= Villager[i].Y then
				Villager[i].Y = Villager[i].Y - Villager[i].Speed
				--cfm:play()
			end

			
		
			if coordY < Villager[i].Y and coordX == Villager[i].X then
				Villager[i].IMG = VillagerPics.Up
			end
			if coordY > Villager[i].Y and coordX == Villager[i].X then
				Villager[i].IMG = VillagerPics.Down
			end
			if coordX < Villager[i].X and coordY == Villager[i].Y then
				Villager[i].IMG = VillagerPics.Left
			end
			if coordX > Villager[i].X and coordY == Villager[i].Y then
				Villager[i].IMG = VillagerPics.Right
			end
			if coordY < Villager[i].Y and coordX < Villager[i].X then
				Villager[i].IMG = VillagerPics.UpLeft
			end
			if coordY > Villager[i].Y and coordX > Villager[i].X then
				Villager[i].IMG = VillagerPics.DownRight
			end
			if coordY > Villager[i].Y and coordX < Villager[i].X then
				Villager[i].IMG = VillagerPics.DownLeft
			end
			if coordY < Villager[i].Y and coordX > Villager[i].X then
				Villager[i].IMG = VillagerPics.UpRight
			end
		end
	end
	
	-- Endless Screenshot Save System :D
	if pad:select() then
		screen:save("Screenshots/screenshot"..ScreenCount..".png")
		ScreenCount = ScreenCount + 1
		ScreenCFG = io.open("Game Resources/ScreenCount.cfg", "w")
		ScreenCFG:write(ScreenCount)
		ScreenCFG:close()
	end
	
	if pad:start() then mState = "Menu" end
	
	end -- mState "Game"'s End
	
	screen.waitVblankStart(1)
	screen.flip()
end









































