GameOn = true

CreateBG1 = Image.load("Game Resources/Backgrounds/CreateBG1.png")

White = Color.new(255,255,255)
Black = Color.new(0,0,0)

MapColor = {
Map1 = Color.new(0,0,0),
Map2 = Color.new(0,0,0),
Map3 = Color.new(0,0,0),
}

Arial = Font.load("Font/Arial.TTF")
Arial:setPixelSizes(11,11)
GameCreated = ""

CreatedCFG1 = io.open("Configuration/Map 1/GameCreated.cfg", "r")
GameCreated1 = tostring(CreatedCFG1:read())
CreatedCFG1:close()

CreatedCFG2 = io.open("Configuration/Map 2/GameCreated.cfg", "r")
GameCreated2 = tostring(CreatedCFG2:read())
CreatedCFG2:close()

CreatedCFG3 = io.open("Configuration/Map 3/GameCreated.cfg", "r")
GameCreated3 = tostring(CreatedCFG3:read())
CreatedCFG3:close()

SaveIndex = 1

while GameOn do
	pad = Controls.read()
	screen:clear()
	
	screen:blit(0,0,CreateBG1)
	screen:fontPrint(Arial,215,15,"Load Game",Black)
	screen:fontPrint(Arial,220,80,"Load Map 1",MapColor.Map1)
	screen:fontPrint(Arial,220,100,"Load Map 2",MapColor.Map2)
	screen:fontPrint(Arial,220,120,"Load Map 3",MapColor.Map3)
	
	if pad:down() then SaveIndex = SaveIndex + 1 end
	if pad:up() then SaveIndex = SaveIndex - 1 end
	
	if SaveIndex == 1 then
			MapColor.Map1 = Color.new(255,255,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 2 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(255,255,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 3 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(255,255,0)
		end
		
	if SaveIndex >= 4 then SaveIndex = 3 end
	if SaveIndex <= 0 then SaveIndex = 1 end

	if pad:circle() then
		dofile("MainMenu.lua")
	end
	
	if pad:cross() then
		if SaveIndex == 1 then
			MapChoise = 1
			MapChoiseCFG = io.open("Configuration/MapChoise.cfg", "w")
			MapChoiseCFG:write(MapChoise)
			MapChoiseCFG:close()
			dofile("GameScript.lua")
		end
		if SaveIndex == 2 then
			MapChoise = 2
			MapChoiseCFG = io.open("Configuration/MapChoise.cfg", "w")
			MapChoiseCFG:write(MapChoise)
			MapChoiseCFG:close()
			dofile("GameScript.lua")
		end
		if SaveIndex == 3 then
			MapChoise = 3
			MapChoiseCFG = io.open("Configuration/MapChoise.cfg", "w")
			MapChoiseCFG:write(MapChoise)
			MapChoiseCFG:close()
			dofile("GameScript.lua")
		end
	end

	
	screen.waitVblankStart(1)
	screen.flip()
end



