GameOn = true

CreateBG1 = Image.load("Game Resources/Backgrounds/CreateBG1.png")

MapColor = {
	Map1 = Color.new(0,0,0),
	Map2 = Color.new(0,0,0),
	Map3 = Color.new(0,0,0),
}

Arial = Font.load("Font/Arial.TTF")
Arial:setPixelSizes(11,11)

SaveIndex = 1

while GameOn do
	pad = Controls.read()
	screen:clear()
	
	screen:blit(0,0,CreateBG1)
	screen:fontPrint(Arial,210,20,"Load Game",Black)
	screen:fontPrint(Arial,200,80,"Load Saved Game 1",MapColor.Map1)
	screen:fontPrint(Arial,200,110,"Load Saved Game 2",MapColor.Map2)
	screen:fontPrint(Arial,200,140,"Load Saved Game 3",MapColor.Map3)
	
	if pad:down() then
		if pressed.up == false then
			pressed.up = true
			SaveIndex = SaveIndex + 1
		end
	else
		pressed.up = false
	end
	if pad:up() then
		if pressed.up == false then
			pressed.up = true
			SaveIndex = SaveIndex - 1
		end
	else
		pressed.up = false
	end
	
	if SaveIndex == 1 then
			MapColor.Map1 = Color.new(255,255,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 2 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(255,255,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 3 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(255,255,0)
		end
		
	if SaveIndex >= 4 then SaveIndex = 3 end
	if SaveIndex <= 0 then SaveIndex = 1 end

	if pad:circle() then
		dofile("MainMenu.lua")
	end
	
	if pad:cross() then
		if SaveIndex == 1 then
			--MapChoise = 1
			SavePath("1")
			dofile("GameScript.lua")
		end
		if SaveIndex == 2 then
			--MapChoise = 2
			SavePath("2")
			dofile("GameScript.lua")
		end
		if SaveIndex == 3 then
			--MapChoise = 3
			SavePath("3")
			dofile("GameScript.lua")
		end
	end

	
	screen.waitVblankStart(1)
	screen.flip()
end