GameOn = true

Red    = Color.new(255, 	0,		0)
Blue   = Color.new(0, 	0,		255)
Green  = Color.new(0, 	255, 	0)
Black  = Color.new(0, 	0, 		0)
White  = Color.new(255,	255,	255)
Purple = Color.new(91,	16,		50)
Yellow =  Color.new(255,255,0)

red    = Color.new(255, 	0,		0)
blue   = Color.new(0, 	0,		255)
green  = Color.new(0, 	255, 	0)
black  = Color.new(0, 	0, 		0)
white  = Color.new(255,	255,	255)
purple = Color.new(91,	16,		50)
yellow =  Color.new(255,255,0)

MV = 0.1 -- MainVersion
DevState = "indev"
local UpdData = "8.08.2018"
Update = 2
local UpdateName = "Adaptive Update"

local BG = Image.load("Game Resources/Backgrounds/MenuBG.png")--BackGround
local P1 = Image.load("Game Resources/Backgrounds/Panel1.png")--Panel1
local P2 = Image.load("Game Resources/Backgrounds/Panel2.png")--Panel2
local EB = Image.load("Game Resources/Buttons/Buttons/EmptyButton.png")--EmptyButton
local SB = 0 --SelectButton

local DT1 = "Standart Game With Optional" -- DT = Description Text
local DT2 = "Rules"
local DT3 = ""

Arial = Font.load("Font/Arial.TTF")

-- Endless Screenshot Save System
function Screenshot()
	
	ScreenCFG = io.open("Game Resources/ScreenCount.cfg", "r")
	ScreenCount = tonumber(ScreenCFG:read())
	ScreenCFG:close()
	
	--System.getDate()
	screen:save("Screenshots/screenshot"..ScreenCount..".png")
	ScreenCount = ScreenCount + 1
	
	ScreenCFG = io.open("Game Resources/ScreenCount.cfg", "w")
	ScreenCFG:write(ScreenCount)
	ScreenCFG:close()
	
end

--Draws a rectangle outline
function drawrect(x1,x2,y1,y2,COLOR)
	screen:drawLine(x1,y1,x2,y1,COLOR)
	screen:drawLine(x1,y1,x1,y2,COLOR)
	screen:drawLine(x1,y2,x2,y2,COLOR)
	screen:drawLine(x2,y1,x2,y2,COLOR)
end

--Modified screen:fillRect()
function drawfilledRect(sx,sy,w,h,COLOR)
	screen:fillRect(sx,sy,w,h,COLOR)
end

Info = {
	TC = {
		Width = 156,
		Height = 90,
	},
	House = {
		Width = 100,
		Height = 75,
	},
	
	Villager = {
		Width = 28,
		Height = 44,
	},
	Militia = {
		Width = 28,
		Height = 45,
	},
	
	
	
	Tree = {
		Width = 63,
		Height = 100,
	},
	Berry = {
		Width = 55,
		Height = 40,
	},
	Gold = {
		Width = 63,
		Height = 37,
	},
	Stone = {
		Width = 60,
		Height = 28,
	},
	
	
	
	Tile = {
		Width = 81,
		Height = 48,
	},
}

function LoadCustomMap(FileName, Format)
	if Format == "Default" or Format == "Def" then
		Format = "scn2psp"
	end
	dofile("Scenario/"..FileName.."."..Format)
end

function SavePath(Number)
	PathCFG = io.open("Configuration/MapChoise.cfg", "w")
	PathCFG:write('MapChoise = '..string.format('%q',Number))
	PathCFG:close()
end

pressed={
	left=false,
	up=false,
	right=false,
	down=false,
	r=false,
	l=false,
	start=false,
	sel=false,
	cross=false,
	triangle=false,
	square=false,
	circle=false
}

function Fade(Speed)
	FadeBG = Image.createEmpty(480,272)
	Alpha = 0
	FadeColor = Color.new(0,0,0,Alpha)
	
	FadeBG:clear(FadeColor)
	while true do
		screen:blit(0,0,FadeBG)
		if Alpha < 255 then
			Alpha = Alpha + Speed
		else
			break
		end
		FadeColor = Color.new(0,0,0,Alpha)
		FadeBG:clear(FadeColor)
		
		screen.waitVblankStart()
		screen.flip()
	end
	screen.flip()
end

Mp3me.stop()
Mp3me.load("Sounds/stream/xopen.mp3")
Mp3me.play()

TimerBool = false
Directer = nil
TimerFade = 0

while GameOn do
	pad = Controls.read()

	screen:blit(0,0,BG)
	screen:blit(209,198,P1)
	screen:blit(224,0,P2)
	screen:blit(250,50,EB)
	screen:blit(250,90,EB)
	screen:blit(250,130,EB)
	
	Arial:setPixelSizes(11,11)
	screen:fontPrint(Arial,230,219,DT1,white)
	screen:fontPrint(Arial,230,231,DT2,white)
	screen:fontPrint(Arial,230,241,DT3,white)
	
	Arial:setPixelSizes(9,9)
	screen:fontPrint(Arial,5,249,"Lua Edition  -  "..UpdateName,white)
	screen:fontPrint(Arial,5,257,"MasterMen - Main Programming, HardPic - Programming Help and Optimization",white)
	screen:fontPrint(Arial,5,265,"Age Of Empires II "..DevState.." "..MV.." By MasterMen. Update from "..UpdData.."  ("..Update..")",white)
	
	Arial:setPixelSizes(13,13)
	if SB == 0 then 
		screen:fontPrint(Arial,300,69,"Standart Game",yellow)
		screen:fontPrint(Arial,310,109,"Load Game",white)
		screen:fontPrint(Arial,310,149,"Custom Map",white)
	elseif SB == 1 then
		screen:fontPrint(Arial,300,69,"Standart Game",white)
		screen:fontPrint(Arial,310,109,"Load Game",yellow)
		screen:fontPrint(Arial,310,149,"Custom Map",white)
	elseif SB == 2 then
		screen:fontPrint(Arial,300,69,"Standart Game",white)
		screen:fontPrint(Arial,310,109,"Load Game",white)
		screen:fontPrint(Arial,310,149,"Custom Map",yellow)
	end
	
	--if AllSelect == 1 then
	--	SingleplayerIcon = Image.load("Game Resources/MenuIcons/SingleplayerIconON.png")
	--end
	
	if TimerBool == true then
		TimerFade = TimerFade + 1
	end
	if TimerFade > 25 then
		Fade(25)
		if Directer == 0 then
			TimerBool = false
			TimerFade = 0
			dofile("CreateGame.lua")
		elseif Directer == 1 then
			TimerBool = false
			TimerFade = 0
			dofile("LoadGameMenu.lua")
		elseif Directer == 2 then
			TimerBool = false
			TimerFade = 0
			dofile("CustomMap.lua")
		end
	end
	
	if pad:up() then
		if pressed.up == false then
			pressed.up = true
			SB = SB - 1
		end
	else
		pressed.up = false
	end
	
	if pad:down() then 
		if pressed.down == false then
			pressed.down = true
			SB = SB + 1 
		end
	else
		pressed.down = false
	end
	
	if SB == 0 then
		DT1 = "Standart Game With Optional"
		DT2 = "Rules"
		DT3 = ""
	elseif SB == 1 then
		DT1 = "Play Loaded Game!"
		DT2 = ""
		DT3 = ""
	elseif SB == 2 then
		DT1 = "Play Custom Maded Maps Made by"
		DT2 = "Game's Community!"
		DT3 = ""
	end
	
	if SB > 2 then SB = 0 end
	if SB < 0 then SB = 2 end
	
	if pad:cross() then
		Mp3me.stop()
		Mp3me.load("Sounds/select2.mp3")
		Mp3me.play()
		if SB == 0 then
			Directer = 0
			TimerBool = true
		elseif SB == 1 then
			Directer = 1
			TimerBool = true
		elseif SB == 2 then
			Directer = 2
			TimerBool = true
		end
	end
	
	if pad:select() then
		Screenshot()
	end

	screen.waitVblankStart(1)
	screen.flip()
end