Cursor = {
	new = function()
		local o = {
			X = nil,
			Y = nil,
			MapX = nil,
			MapY = nil,
			TarX = nil,
			TarY = nil,
			W = nil,
			H = nil,
			Tex = nil,
			TypeOld = nil,
			Type = nil,
				-- DEF (Default)
				-- ATT (Attack)
				-- COL (Collect)
				-- REP (Repair)
				-- MON (Monk)
			Sensity = nil,
				
			SetDefaults = function(self)
				self.X = 100
				self.Y = 100
				self.MapX = 0
				self.MapY = 0
				self.TarX = 100
				self.TarY = 100
				self.Tex = spr.Game.Cursor.DEF
				self.TypeOld = ""
				self.Type = "DEF"
				self.Sensity = 15
			end,
			
			InitMove = function(self)
				local dx = pge.controls.analogx()
				if math.abs(dx) > 32 then
					self.X = self.X + dx / self.Sensity
					self.X = math.floor(self.X)
				end
				
				local dy = pge.controls.analogy()
				if math.abs(dy) > 32 then
					self.Y = self.Y + dy / self.Sensity
					self.Y = math.floor(self.Y)
				end
			end,
			
			SetTex = function(self)
				if self.TypeOld ~= self.Type then
					self.TypeOld = Type
					
					if self.Type == "DEF" then
						self.Tex = spr.Game.Cursor.DEF
					elseif self.Type == "ATT" then
						self.Tex = spr.Game.Cursor.ATT
					elseif self.Type == "COL" then
						self.Tex = spr.Game.Cursor.COL
					elseif self.Type == "REP" then
						self.Tex = spr.Game.Cursor.REP
					elseif self.Type == "MON" then
						self.Tex = spr.Game.Cursor.MON
					else
						--self.Tex = spr.Game.Cursor.self.Type
					end
				end
			end,
			
			InitRender = function(self)
				self.Tex:activate()
				self.Tex:draweasy(self.X, self.Y)
			end,
			
			InitSelect = function(self, player, ent, cam, ctrl)
				if ctrl == "L" then
					if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
						if self.X - cam.X > ent.X - cam.X and self.X - cam.X < ent.X - cam.X + ent.Tex.W  and self.Y - cam.Y > ent.Y - cam.Y and self.Y - cam.Y < ent.Y - cam.Y + ent.Tex.H  then
							player.CL[1] = {TYPE = "Unit", ID = 1}
						end
					--[[else
						for i = 1, player.CLM do
							player.CL[i] = nil
						end--]]
					end
				end
			end,
			
			SetUnitTarget = function(self, player, cam, ctrl)
				if ctrl == "R" then
					if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
						for i = 1, player.CLM do
							if player.CL[i] ~= nil then
								if player.CL[i].TYPE == "Unit" then
									self.MapX = self.X - cam.X
									self.MapY = self.Y - cam.Y
									Ent.Unit[player.CL[i].ID].TarX = self.MapX
									Ent.Unit[player.CL[i].ID].TarY = self.MapY
									local vilsnd = Random(1, 4)
									me.Player:PlaySound("VillagerM", "Walk", vilsnd)
									vilsnd = nil
								elseif player.CL[i].TYPE == "Building" or player.CL[i].TYPE == "Object" then 
									player.CL[i] = nil
								end
							end
						end
					end
				end
				
			end
			
		}
		return o
	end
}