-- Created By CoderX, Team Matrix (2006 Year)
-- GENERAL PUBLIC LICENSE V0.2

-- Game Continue by MasterMen in 2017 マスターメン
-- Attempt #2 (cuz first was deleted :/)
-- Start: 2.06.2017, 14:48 (First Screenshot ever)

mState = "Game"
--"Game"
--"Menu"
--"Options"

Global = {
	
	World = {
		Pop = 0,
		Theme = "",
	},
	
	Player = {
		
		Wood = 0,
		Food = 0,
		Stone = 0,
		Gold = 0,
		Pop = 0,
		MaxPop = 20,
		Color = Color.new(0,0,0),
		Nick = "",
		Civ = "",
		Age = "Dark Age",
		-- Dark Age, Feudal Age, Castle Age, Imperial Age
		
		TC = {
			Cost = {
				Food = 0,
				Wood = 0,
				Stone = 0,
				Gold = 0,
			},
			MaxHP = 2400,
			Att = 5,
			Pop = 1,
		},
		House = {
			Cost = {
				Food = 0,
				Wood = 0,
				Stone = 0,
				Gold = 0,
			},
			MaxHP = 500,
			Pop = 1,
		},
		Villager = {
			Cost = {
				Food = 0,
				Wood = 0,
				Stone = 0,
				Gold = 0,
			},
			MaxInv = 10,
			MaxHP = 50,
			Att = 3,
			Speed = 2,
		},
		Militia = {
			Cost = {
				Food = 0,
				Wood = 0,
				Stone = 0,
				Gold = 0,
			},
			MaxHP = 50,
			Att = 3,
			Speed = 3,
		},
	},
	
	
	
	
	Bot1 = {
		
	},
	
	
}

ScreenCount = 0

MapColor = {
	Map1 = Color.new(0,0,0),
	Map2 = Color.new(0,0,0),
	Map3 = Color.new(0,0,0),
}

--[[
MapChoiseCFG = io.open("Configuration/MapChoise.cfg", "r")
MapChoise = tostring(MapChoiseCFG:read())
MapChoiseCFG:close()
--]]

MapChoise = ""
dofile("Configuration/MapChoise.cfg")

-- load Config, not a world xD
function LoadWorld()
	
	MapPath = "Temp"
	
	ThemeCFG = io.open("Configuration/"..MapPath.."/MapTheme.cfg", "r")
	MapType = tostring(ThemeCFG:read())
	ThemeCFG:close()
	
	dofile("Configuration/"..MapPath.."/Color.cfg")
	
	CivCFG = io.open("Configuration/"..MapPath.."/Civilization.cfg", "r")
	Global.Player.Civ = tostring(CivCFG:read())
	CivCFG:close()
	
	-- Resources \/
	
	ResCFG = io.open("Configuration/Temp/Resources.cfg", "r")
	Global.Player.Resources = tostring(ResCFG:read())
	ResCFG:close()
end

function SaveConfig(Num)
	ThemeCFG = io.open("Configuration/"..Num.."/MapTheme.cfg", "w")
	ThemeCFG:write(MapType)
	ThemeCFG:close()
	
	ColorCFG = io.open("Configuration/"..Num.."/Color.cfg", "w")
	ColorCFG:write('Global.Player.Color = '..string.format('%q',Global.Player.Color))
	ColorCFG:close()
	
	ResCFG = io.open("Configuration/"..Num.."/Resources.cfg", "w")
	ResCFG:write(Global.Player.Resources)
	ResCFG:close()
	
	CivCFG = io.open("Configuration/"..Num.."/Civilization.cfg", "w")
	CivCFG:write(Global.Player.Civ)
	CivCFG:close()
	
	VersionCFG = io.open("Configuration/"..Num.."/WorldVer.cfg", "w")
	VersionCFG:write(MV)
	VersionCFG:close()
	
end

function SaveGame(Name, DT1, DT2, DT3, MapGenre, Diff, Version, Update)
	SavedGameCFG = io.open("Configuration/Map1.cfg", "w")
	
	SavedGameCFG:write("Scenario = {\n")
	SavedGameCFG:write("	Name = "..string.format('%q',Name)..",\n")
	SavedGameCFG:write("	DT1 = "..string.format('%q',DT1)..",\n")
	SavedGameCFG:write("	DT2 = "..string.format('%q',DT2)..",\n")
	SavedGameCFG:write("	DT3 = "..string.format('%q',DT3)..",\n")
	SavedGameCFG:write("	MapGenre = "..string.format('%q',MapGenre)..",\n")
	SavedGameCFG:write("	Difficult = "..string.format('%q',Diff)..",\n")
	SavedGameCFG:write("	Version = "..Version..",\n")
	SavedGameCFG:write("	Update = "..Update..",\n")
	SavedGameCFG:write("}\n\n")
	
	SavedGameCFG:write("Global = {\n\n")
	SavedGameCFG:write("	World = {\n")
	SavedGameCFG:write("		Pop = 0,\n")
	SavedGameCFG:write("		Theme = "..string.format('%q',Global.World.Theme)..",\n")
	SavedGameCFG:write("	},\n\n")
	SavedGameCFG:write("	Player = {\n")
	SavedGameCFG:write("		Wood = "..Global.Player.Wood..",\n")
	SavedGameCFG:write("		Food = "..Global.Player.Food..",\n")
	SavedGameCFG:write("		Stone = "..Global.Player.Stone..",\n")
	SavedGameCFG:write("		Gold = "..Global.Player.Gold..",\n")
	SavedGameCFG:write("		Pop = "..Global.Player.Pop..",\n")
	SavedGameCFG:write("		MaxPop = "..Global.Player.MaxPop..",\n")
	SavedGameCFG:write("		Color = "..string.format('%q',Global.Player.Color)..",\n")
	SavedGameCFG:write("		NickCol = nil,\n")
	SavedGameCFG:write("		Nick = "..string.format('%q',Global.Player.Nick)..",\n")
	SavedGameCFG:write("		Civ = "..string.format('%q',Global.Player.Civ)..",\n")
	SavedGameCFG:write("		Age = "..string.format('%q',Global.Player.Age)..",\n\n")
	SavedGameCFG:write("		TC = {\n")
	SavedGameCFG:write("			Cost = {\n")
	SavedGameCFG:write("				Wood = "..Global.Player.TC.Cost.Wood..",\n")
	SavedGameCFG:write("				Food = "..Global.Player.TC.Cost.Food..",\n")
	SavedGameCFG:write("				Gold = "..Global.Player.TC.Cost.Gold..",\n")
	SavedGameCFG:write("				Stone = "..Global.Player.TC.Cost.Stone..",\n")
	SavedGameCFG:write("			},\n")
	SavedGameCFG:write("			MaxHP = "..Global.Player.TC.MaxHP..",\n")
	SavedGameCFG:write("			Att = "..Global.Player.TC.Att..",\n")
	SavedGameCFG:write("			Pop = "..Global.Player.TC.Pop..",\n")
	SavedGameCFG:write("		},\n")
	SavedGameCFG:write("		House = {\n")
	SavedGameCFG:write("			Cost = {\n")
	SavedGameCFG:write("				Wood = "..Global.Player.House.Cost.Wood..",\n")
	SavedGameCFG:write("				Food = "..Global.Player.House.Cost.Food..",\n")
	SavedGameCFG:write("				Gold = "..Global.Player.House.Cost.Gold..",\n")
	SavedGameCFG:write("				Stone = "..Global.Player.House.Cost.Stone..",\n")
	SavedGameCFG:write("			},\n")
	SavedGameCFG:write("			MaxHP = "..Global.Player.House.MaxHP..",\n")
	SavedGameCFG:write("			Pop = "..Global.Player.House.Pop..",\n")
	SavedGameCFG:write("		},\n")
	SavedGameCFG:write("		Villager = {\n")
	SavedGameCFG:write("			Cost = {\n")
	SavedGameCFG:write("				Wood = "..Global.Player.Villager.Cost.Wood..",\n")
	SavedGameCFG:write("				Food = "..Global.Player.Villager.Cost.Food..",\n")
	SavedGameCFG:write("				Gold = "..Global.Player.Villager.Cost.Gold..",\n")
	SavedGameCFG:write("				Stone = "..Global.Player.Villager.Cost.Stone..",\n")
	SavedGameCFG:write("			},\n")
	SavedGameCFG:write("			MaxHP = "..Global.Player.Villager.MaxHP..",\n")
	SavedGameCFG:write("			MaxInv = "..Global.Player.Villager.MaxInv..",\n")
	SavedGameCFG:write("			Att = "..Global.Player.Villager.Att..",\n")
	SavedGameCFG:write("			Speed = "..Global.Player.Villager.Speed..",\n")
	SavedGameCFG:write("		},\n")
	SavedGameCFG:write("		Militia = {\n")
	SavedGameCFG:write("			Cost = {\n")
	SavedGameCFG:write("				Wood = "..Global.Player.Militia.Cost.Wood..",\n")
	SavedGameCFG:write("				Food = "..Global.Player.Militia.Cost.Food..",\n")
	SavedGameCFG:write("				Gold = "..Global.Player.Militia.Cost.Gold..",\n")
	SavedGameCFG:write("				Stone = "..Global.Player.Militia.Cost.Stone..",\n")
	SavedGameCFG:write("			},\n")
	SavedGameCFG:write("			MaxHP = "..Global.Player.Militia.MaxHP..",\n")
	SavedGameCFG:write("			Att = "..Global.Player.Militia.Att..",\n")
	SavedGameCFG:write("			Speed = "..Global.Player.Militia.Speed..",\n")
	SavedGameCFG:write("		},\n")
	SavedGameCFG:write("	},\n")
	SavedGameCFG:write("}\n\n")
	
	SavedGameCFG:write("function LoadObj()\n")
	
	-- Villager
	SavedGameCFG:write("\nVillager = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("Villager["..i.."] = {MaxHP = Global.Player.Villager.MaxHP, HP = "..Villager[i].HP..", Attack = Global.Player.Villager.Att, Speed = Global.Player.Villager.Speed, ")
		if Villager[i].Target ~= nil then
			SavedGameCFG:write("Target = "..Villager[i].Target..", ")
		else
			SavedGameCFG:write("Target = nil, ")
		end
		
		if Villager[i].LastTarget ~= nil then
			SavedGameCFG:write("LastTarget = "..Villager[i].LastTarget..", ")
		else
			SavedGameCFG:write("LastTarget = nil, ")
		end
		
		SavedGameCFG:write("TarX = "..Villager[i].TarX..", TarY = "..Villager[i].TarY..", ")
		if Villager[i].Follow == true then
			SavedGameCFG:write("Follow = true, ")
		elseif Villager[i].Follow == false then
			SavedGameCFG:write("Follow = false, ")
		end
		SavedGameCFG:write("Wood = "..Villager[i].Wood..", Gold = "..Villager[i].Gold..", Stone = "..Villager[i].Stone..", Food = "..Villager[i].Food..", ")
		if Villager[i].Exists == true then
			SavedGameCFG:write("Exists = true, ")
		elseif Villager[i].Exists == false then
			SavedGameCFG:write("Exists = false, ")
		end
		if Villager[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif Villager[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		SavedGameCFG:write("Type = "..Villager[i].Type..", ")
		if Villager[i].Type == 1 then
			SavedGameCFG:write("IMG = spr.uni.VillagerMale.Down")
		elseif Villager[i].Type == 2 then
			SavedGameCFG:write("IMG = spr.uni.VillagerFemale.Down")
		end
		SavedGameCFG:write(", X = "..Villager[i].X..", Y = "..Villager[i].Y.."}\n")
	end
	
	
	
	-- Militia
	SavedGameCFG:write("\nMilitia = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("Militia["..i.."] = {MaxHP = Global.Player.Militia.MaxHP, HP = "..Militia[i].HP..", Attack = Global.Player.Militia.Att, Speed = Global.Player.Militia.Speed, ")
		if Militia[i].Target ~= nil then
		SavedGameCFG:write("Target = "..Militia[i].Target..", ")
		else
			SavedGameCFG:write("Target = nil, ")
		end
		
		if Militia[i].LastTarget ~= nil then
			SavedGameCFG:write("LastTarget = "..Militia[i].LastTarget..", ")
		else
			SavedGameCFG:write("LastTarget = nil, ")
		end
		SavedGameCFG:write("TarX = "..Militia[i].TarX..", ")
		SavedGameCFG:write("TarY = "..Militia[i].TarY..", ")
		if Militia[i].Follow == true then
			SavedGameCFG:write("Follow = true, ")
		elseif Militia[i].Follow == false then
			SavedGameCFG:write("Follow = false, ")
		end
		if Militia[i].Exists == true then
			SavedGameCFG:write("Exists = true, ")
		elseif Militia[i].Exists == false then
			SavedGameCFG:write("Exists = false, ")
		end
		if Militia[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif Militia[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		SavedGameCFG:write("IMG = spr.uni.Militia.Down, X = "..Militia[i].X..", Y = "..Militia[i].Y.."}\n")
	end
	
	
	-- Town Center
	SavedGameCFG:write("\nTownCenter = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("TownCenter["..i.."] = {MaxHP = "..Global.Player.TC.MaxHP..", HP = "..TownCenter[i].HP..", ")
		if TownCenter[i].Builded == true then
			SavedGameCFG:write("Builded = true, ")
		elseif TownCenter[i].Builded == false then
			SavedGameCFG:write("Builded = false, ")
		end
		if TownCenter[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif TownCenter[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		if Global.Player.Age == "Dark Age" then
			SavedGameCFG:write("IMG = spr.build.TC.Dark, ")
		end
		SavedGameCFG:write("X = "..TownCenter[i].X..", Y = "..TownCenter[i].Y.."}\n")
	end
	
	
	
	-- House
	SavedGameCFG:write("\nHouse = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("House["..i.."] = {MaxHP = Global.Player.House.MaxHP, HP = "..House[i].HP..", ")
		if House[i].Builded == true then
			SavedGameCFG:write("Builded = true, ")
		elseif House[i].Builded == false then
			SavedGameCFG:write("Builded = false, ")
		end
		if House[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif House[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		if House[i].IMG == spr.build.House.DarkTy1 then
			SavedGameCFG:write("IMG = spr.build.House.DarkTy1, ")
		elseif House[i].IMG == spr.build.House.DarkTy2 then
			SavedGameCFG:write("IMG = spr.build.House.DarkTy2, ")
		elseif House[i].IMG == spr.build.House.DarkTy3 then
			SavedGameCFG:write("IMG = spr.build.House.DarkTy3, ")
		end
		SavedGameCFG:write("X = "..House[i].X..", Y = "..House[i].Y.."}\n")
	end
	
	-- Mineral
	SavedGameCFG:write("\nMineral = {}\n")
	SavedGameCFG:write("Mineral[1] = {MaxGold = "..Mineral[1].MaxGold..", Gold = "..Mineral[1].Gold..", ")
	if Mineral[1].Exists == true then
		SavedGameCFG:write("Exists = true, ")
	elseif Mineral[1].Exists == false then
		SavedGameCFG:write("Exists = false, ")
	end
	if Mineral[1].Selected == true then
		SavedGameCFG:write("Selected = true, ")
	elseif Mineral[1].Selected == false then
		SavedGameCFG:write("Selected = false, ")
	end
	SavedGameCFG:write("IMG = spr.res.Crystal.Ty1, ")
	SavedGameCFG:write("X = "..Mineral[1].X..", Y = "..Mineral[1].Y.."}\n")
	
	-- Tree
	SavedGameCFG:write("\nTree = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("Tree["..i.."] = {MaxWood = "..Tree[i].MaxWood..", Wood = "..Tree[i].Wood..", ")
		if Tree[i].Exists == true then
			SavedGameCFG:write("Exists = true, ")
		elseif Tree[i].Exists == false then
			SavedGameCFG:write("Exists = false, ")
		end
		if Tree[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif Tree[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		if Tree[i].IMG == spr.res.Tree.Oak1 then
			SavedGameCFG:write("IMG = spr.res.Tree.Oak1, ")
		elseif Tree[i].IMG == spr.res.Tree.Oak2 then
			SavedGameCFG:write("IMG = spr.res.Tree.Oak2, ")
		elseif Tree[i].IMG == spr.res.Tree.Oak3 then
			SavedGameCFG:write("IMG = spr.res.Tree.Oak3, ")
		end
		SavedGameCFG:write("X = "..Tree[i].X..", Y = "..Tree[i].Y.."}\n")
	end
	
	
	
	-- Berry
	SavedGameCFG:write("\nBerry = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("Berry["..i.."] = {MaxFood = "..Berry[i].MaxFood..", Food = "..Berry[i].Food..", ")
		if Berry[i].Exists == true then
			SavedGameCFG:write("Exists = true, ")
		elseif Berry[i].Exists == false then
			SavedGameCFG:write("Exists = false, ")
		end
		if Berry[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif Berry[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		if Berry[i].IMG == spr.res.Food.Ty1 then
			SavedGameCFG:write("IMG = spr.res.Food.Ty1, ")
		elseif Berry[i].IMG == spr.res.Food.Ty2 then
			SavedGameCFG:write("IMG = spr.res.Food.Ty2, ")
		elseif Berry[i].IMG == spr.res.Food.Ty3 then
			SavedGameCFG:write("IMG = spr.res.Food.Ty3, ")
		end
		SavedGameCFG:write("X = "..Berry[i].X..", Y = "..Berry[i].Y.."}\n")
	end
	
	
	
	-- Gold
	SavedGameCFG:write("\nGold = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("Gold["..i.."] = {MaxGold = "..Gold[i].MaxGold..", Gold = "..Gold[i].Gold..", ")
		if Gold[i].Exists == true then
			SavedGameCFG:write("Exists = true, ")
		elseif Gold[i].Exists == false then
			SavedGameCFG:write("Exists = false, ")
		end
		if Gold[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif Gold[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		if Gold[i].IMG == spr.res.Gold.Ty1 then
			SavedGameCFG:write("IMG = spr.res.Gold.Ty1, ")
		end
		SavedGameCFG:write("X = "..Gold[i].X..", Y = "..Gold[i].Y.."}\n")
	end
	
	
	
	-- Stone
	SavedGameCFG:write("\nStone = {}\n")
	for i = 1, 8 do
		SavedGameCFG:write("Stone["..i.."] = {MaxStone = "..Stone[i].MaxStone..", Stone = "..Stone[i].Stone..", ")
		if Stone[i].Exists == true then
			SavedGameCFG:write("Exists = true, ")
		elseif Stone[i].Exists == false then
			SavedGameCFG:write("Exists = false, ")
		end
		if Stone[i].Selected == true then
			SavedGameCFG:write("Selected = true, ")
		elseif Stone[i].Selected == false then
			SavedGameCFG:write("Selected = false, ")
		end
		if Stone[i].IMG == spr.res.Stone.Ty1 then
			SavedGameCFG:write("IMG = spr.res.Stone.Ty1, ")
		elseif Stone[i].IMG == spr.res.Stone.Ty2 then
			SavedGameCFG:write("IMG = spr.res.Stone.Ty2, ")
		end
		SavedGameCFG:write("X = "..Stone[i].X..", Y = "..Stone[i].Y.."}\n")
	end
	SavedGameCFG:write("\nend")
	SavedGameCFG:close()
end

function ResCheck()
	if Global.Player.Resources == "Zero" then
		Global.Player.Wood = 0
		Global.Player.Food = 0
		Global.Player.Stone = 0
		Global.Player.Gold = 0
	end
	if Global.Player.Resources == "Little" then
		Global.Player.Wood = 200
		Global.Player.Food = 200
		Global.Player.Stone = 100
		Global.Player.Gold = 100
	end
	if Global.Player.Resources == "Normal" then
		Global.Player.Wood = 600
		Global.Player.Food = 600
		Global.Player.Stone = 400
		Global.Player.Gold = 400
	end
	if Global.Player.Resources == "Many" then
		Global.Player.Wood = 1200
		Global.Player.Food = 1200
		Global.Player.Stone = 750
		Global.Player.Gold = 750
	end
	-- Don't use cheats!
end

SaveIndex = 1

if MapChoise == "C1" then
	LoadCustomMap("CustomMap1", "scn2psp")
elseif MapChoise == "C2" then
	LoadCustomMap("CustomMap2", "scn2psp")
elseif MapChoise == "C3" then
	LoadCustomMap("CustomMap3", "scn2psp")
elseif MapChoise == "0" then
	LoadWorld()
	ResCheck()
elseif MapChoise == "1" then
	dofile("Configuration/Map1.cfg")
elseif MapChoise == "2" then
	dofile("Configuration/Map2.cfg")
elseif MapChoise == "3" then
	dofile("Configuration/Map3.cfg")
end

if Global.Player.Color == "Blue" then Global.Player.NickCol = Color.new(0,0,255) end
if Global.Player.Color == "Red" then Global.Player.NickCol = Color.new(255,0,0) end

spr = {
	uni = {
		--Villager = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/MVillager.png"),
		VillagerMale = {
			Down = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN1.png"),
			Right = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN6.png"),
			Left = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN3.png"),
			Up = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN5.png"), -- No (4)
			UpLeft = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN4.png"), -- No (43)
			UpRight = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN6.png"), -- No (42)
			DownLeft = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN2.png"),
			DownRight = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Male/VMBAS_FN7.png"),
			Icon = Image.load("Game Resources/Icons/Units/"..Global.Player.Color.."/VillagerMaleIcon.jpg"),
		},
		VillagerFemale = {
			Down = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN1.png"),
			Right = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN6.png"),
			Left = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN3.png"),
			Up = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN5.png"),
			UpLeft = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN4.png"),
			UpRight = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN6.png"),
			DownLeft = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN2.png"),
			DownRight = Image.load("Game Resources/Units/Villager/"..Global.Player.Color.."/Female/VFBAS_FN7.png"),
			
			Icon = Image.load("Game Resources/Icons/Units/"..Global.Player.Color.."/VillagerFemaleIcon.jpg"),
		},
		Militia = {
			Down = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN.png"),
			Right = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN7.png"),
			Left = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN2.png"),
			Up = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN4.png"),
			UpLeft = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN3.png"),
			UpRight = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN6.png"),
			DownLeft = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN1.png"),
			DownRight = Image.load("Game Resources/Units/Militia/"..Global.Player.Color.."/SPRMN_FN8.png"),
			
			Icon = Image.load("Game Resources/Icons/Units/"..Global.Player.Color.."/MilitiaIcon.jpg"),
		},
		OnullO = Image.load("Game Resources/Units/Villager/Old/OldOld/noll.png"),
		Select = {
			Small = Image.load("Game Resources/Units/SelSmall.png"),
			Medium = nil,
		},
	},
	
	
	
	build = {
		TC = {
			Dark = Image.load("Game Resources/Buildings/Town Center/"..Global.Player.Color.."/TownCenter.png"),
			
			Icon = Image.load("Game Resources/Icons/Buildings/TownCenter.png"),
		},
		House = {
			DarkTy1 = Image.load("Game Resources/Buildings/House/"..Global.Player.Color.."/House1.png"),
			DarkTy2 = Image.load("Game Resources/Buildings/House/"..Global.Player.Color.."/House2.png"),
			DarkTy3 = Image.load("Game Resources/Buildings/House/"..Global.Player.Color.."/House3.png"),
			
			Icon = Image.load("Game Resources/Icons/Buildings/House.png"),
		},
		Select = {
			S3x3 = Image.load("Game Resources/Buildings/Sel3x3_2.png"),
			S2x2 = Image.load("Game Resources/Buildings/Sel2x2.png"),
			S1x1 = Image.load("Game Resources/Buildings/Sel1x1.png"),
		},
	},
	
	
	
	res = {
		Crystal = {
			Ty1 = Image.load("Game Resources/Resources/Minerals.png")
		},
		Food = {
			Ty1 = Image.load("Game Resources/Resources/Berry/FORAG_NN0.png"),
			Ty2 = Image.load("Game Resources/Resources/Berry/FORAG_NN1.png"),
			Ty3 = Image.load("Game Resources/Resources/Berry/FORAG_NN2.png"),
			Icon = Image.load("Game Resources/Icons/Resources/BerryIco.png"),
		},
		Tree = {
			Oak1 = Image.load("Game Resources/Resources/Tree/Oak/FOAK_NN0.png"),
			Oak2 = Image.load("Game Resources/Resources/Tree/Oak/FOAK_NN1.png"),
			Oak3 = Image.load("Game Resources/Resources/Tree/Oak/FOAK_NN2.png"),
			Icon = Image.load("Game Resources/Icons/Resources/TreeIco.png"),
		},
		Stone = { 
			Ty1 = Image.load("Game Resources/Resources/Stone/STONM_NN0.png"),
			Ty2 = Image.load("Game Resources/Resources/Stone/STONM_NN1.png"),
			Icon = Image.load("Game Resources/Icons/Resources/StoneIco.png"),
		},
		Gold = {
			Ty1 = Image.load("Game Resources/Resources/Gold/Gold1.png"),
			Icon = Image.load("Game Resources/Icons/Resources/GoldIco.png"),
		},
		Artifact = {
			Ty1 = nil,
			Ty2 = nil,
		},
	},
	
	
	
	assets = {
		MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldGrass_MiniMap.png"), -- Grass
		Background = Image.load("Game Resources/Backgrounds/Ground/BGERROR.png"),
		GamePanel = Image.load("Game Resources/Panel/StandartPanel.png"),
		--GamePanel = Image.load("Game Resources/Panel/AlphaPanel.png"),
		ico = {
			Food = Image.load("Game Resources/Icons/Resources/Food.png"),
			Wood = Image.load("Game Resources/Icons/Resources/Wood.png"),
			Gold = Image.load("Game Resources/Icons/Resources/Gold.png"),
			Stone = Image.load("Game Resources/Icons/Resources/Stone.png"),
		},
		Tile = {
			Grass1 = Image.load("Game Resources/Backgrounds/Ground/GrassTile.png"),
		},
		Cursor = {
			Default = Image.load("Game Resources/Cursors/CursorDEF.png"),
			Resources = Image.load("Game Resources/Cursors/CursorRES.png"),
			Attack = Image.load("Game Resources/Cursors/CursorATT.png"),
		},
	},
}

OptionsBG = Image.load("Game Resources/Backgrounds/OptionsBG.png")
PanelBG = Image.load("Game Resources/Backgrounds/PanelBG.png")

GameMenu = Image.load("Game Resources/Backgrounds/GameMenu.png")
EmptyButton = Image.load("Game Resources/Buttons/EmptyButton.png")

if MapChoise == "0" then
	dofile("Storage.lua")
else
	LoadObj()
end


if Global.Player.Nick == "" then
	NickCFG = io.open("Configuration/Nickname.cfg", "r")
	Global.Player.Nick = tostring(NickCFG:read())
	NickCFG:close()
else
	Global.Player.Nick = "Player"
end

null = {}
null[1] = {Exists = true, X = -850, Y = 80, IMG = spr.uni.OnullO}

CurButton = 1
CurButton_old = CurButton

ButtonColor = {
	ResumeGame = Color.new(0,0,0),
	Options = Color.new(0,0,0),
	Controls = Color.new(0,0,0),
	Save = Color.new(0,0,0),
	ExitSave = Color.new(0,0,0),
	Exit = Color.new(0,0,0)
}

BackX={0,0,-480,-480}
BackY={0,-272,0,-272}

Arial = Font.load("Font/Arial.TTF")
Arial:setPixelSizes(11,11)

Cursor = { X = 240, Y = 136, LastX = 0, LastY = 0, IMG_DEF = spr.assets.Cursor.Default, IMG_RES = spr.assets.Cursor.Resources, IMG_ATT =  spr.assets.Cursor.Attack, Speed = 5, Under = nil}

--[[
World = {}
for i = 1, 5 do
	World[i][i] = {Ground = "Grass", Object = nil}
end
--]]

--[[ this is the correct example. I will work on it later...
World = {}
for i = 1, 5 do
	for j = 1, 5 do
		World[i] = {}
		World[i][j] = {Ground = "Grass", Object = nil, ObjPart = Left}
	end
end

i wanna make grid on Update 3 or 4 or maybe 5, idk.
--]]
--[[
World[25][25] {
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,2,0,1,1,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,E,E,E,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,E,E,E,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,E,E,E,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
	{A,A,I,A,A,D,A,A,I,A,A,O,A,A,T,A,A,!,A,A,A,A,A,A,A},
	{A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A,A},
}
--]]




--[[
if MapChoise ~= "C1" or  MapChoise ~= "C2" or MapChoise ~= "C3" then
	-- Load objects
end
--]]





function UnSelectUnits(Type)
	if Type == "for" then
		for i = 1, 8 do
			Villager[i].Selected = false
			Militia[i].Selected = false
		end
	elseif Type == "Classic" then
		Villager[1].Selected = false
		Villager[2].Selected = false
		Villager[3].Selected = false
		Villager[4].Selected = false
		Villager[5].Selected = false
		Villager[6].Selected = false
		Villager[7].Selected = false
		Villager[8].Selected = false
		Militia[1].Selected = false
		Militia[2].Selected = false
		Militia[3].Selected = false
		Militia[4].Selected = false
		Militia[5].Selected = false
		Militia[6].Selected = false
		Militia[7].Selected = false
		Militia[8].Selected = false
	end
end
function UnSelectBuildings(Type)
	if Type == "for" then
		for i = 1, 8 do
			House[i].Selected = false
			TownCenter[i].Selected = false
		end
	elseif Type == "Classic" then
		House[1].Selected = false
		House[2].Selected = false
		House[3].Selected = false
		House[4].Selected = false
		House[5].Selected = false
		House[6].Selected = false
		House[7].Selected = false
		House[8].Selected = false
		TownCenter[1].Selected = false
		TownCenter[2].Selected = false
		TownCenter[3].Selected = false
		TownCenter[4].Selected = false
		TownCenter[5].Selected = false
		TownCenter[6].Selected = false
		TownCenter[7].Selected = false
		TownCenter[8].Selected = false
	end
end
-- Hello MasterMen from 2019 or 2020, look at this shit-code xD
-- I hope you will programm better than 2018 me :)
function UnSelectResources(Type)
	if Type == "for" then
		for i = 1, 8 do
			Berry[i].Selected = false
			Tree[i].Selected = false
			Gold[i].Selected = false
			Stone[i].Selected = false
		end
	elseif Type == "Classic" then
		Berry[1].Selected = false
		Berry[2].Selected = false
		Berry[3].Selected = false
		Berry[4].Selected = false
		Berry[5].Selected = false
		Berry[6].Selected = false
		Berry[7].Selected = false
		Berry[8].Selected = false
		Tree[1].Selected = false
		Tree[2].Selected = false
		Tree[3].Selected = false
		Tree[4].Selected = false
		Tree[5].Selected = false
		Tree[6].Selected = false
		Tree[7].Selected = false
		Tree[8].Selected = false
		Gold[1].Selected = false
		Gold[2].Selected = false
		Gold[3].Selected = false
		Gold[4].Selected = false
		Gold[5].Selected = false
		Gold[6].Selected = false
		Gold[7].Selected = false
		Gold[8].Selected = false
		Stone[1].Selected = false
		Stone[2].Selected = false
		Stone[3].Selected = false
		Stone[4].Selected = false
		Stone[5].Selected = false
		Stone[6].Selected = false
		Stone[7].Selected = false
		Stone[8].Selected = false
	end
end

--[[
bonkSound = Sound.load("bonk.wav",true)

cfm = Sound.load("game/Cits.wav")
--]]

MapTypeBool = true


if MapChoise == "0" then
	-- Loading Map by file's information
	if MapType == "Grass" and MapTypeBool == true then
		MapTypeBool = false
		spr.assets.MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldGrass_MiniMap.png")
		spr.assets.Background = Image.load("Game Resources/Backgrounds/Ground/Grass2.png")
	elseif MapType == "Snow" and MapTypeBool == true then
		MapTypeBool = false
		spr.assets.MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldSnow_MiniMap.png")
		spr.assets.Background = Image.load("Game Resources/Backgrounds/Ground/Snow1.png")
	elseif MapType == "Desert" and MapTypeBool == true then
		MapTypeBool = false
		spr.assets.MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldDesert_MiniMap.png")
		spr.assets.Background = Image.load("Game Resources/Backgrounds/Ground/Desert2.png")
	end
	Global.World.Theme = MapType
else --Global.World.Theme
	if Global.World.Theme == "Grass" and MapTypeBool == true then
		MapTypeBool = false
		spr.assets.MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldGrass_MiniMap.png")
		spr.assets.Background = Image.load("Game Resources/Backgrounds/Ground/Grass2.png")
	elseif Global.World.Theme == "Snow" and MapTypeBool == true then
		MapTypeBool = false
		spr.assets.MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldSnow_MiniMap.png")
		spr.assets.Background = Image.load("Game Resources/Backgrounds/Ground/Snow1.png")
	elseif Global.World.Theme == "Desert" and MapTypeBool == true then
		MapTypeBool = false
		spr.assets.MiniMap = Image.load("Game Resources/Backgrounds/MiniMap/OldDesert_MiniMap.png")
		spr.assets.Background = Image.load("Game Resources/Backgrounds/Ground/Desert2.png")
	end
end
-- Debug Only
tick = 0
lim = 4



WindTimer = 0

while true do
	screen:clear()
	pad = Controls.read()
	
	-- Object Rendering
	
	for i = 1,4 do
		screen:blit(BackX[i], BackY[i], spr.assets.Background, true)
	end
	
	--[[
	for i = 1, 50 do
		for j = 1, 50 do
			screen:blit(i * Info.Tile.Width, j * Info.Tile.Height, spr.assets.Tile.Grass1)
			screen:blit(i * Info.Tile.Width + Info.Tile.Width / 2, j * Info.Tile.Height - Info.Tile.Height / 2, spr.assets.Tile.Grass1)
		end
	end
	--]]
	for i = 1, 8 do -- Optimized
		if TownCenter[i].Builded == true and TownCenter[i].X + Info.TC.Width >= 0 and TownCenter[i].X <= 480 and TownCenter[i].Y + Info.TC.Height >= 0 and TownCenter[i].Y <= 272 then
			if TownCenter[i].Selected == true then
				screen:blit(TownCenter[i].X - 26, TownCenter[i].Y + 25, spr.build.Select.S3x3) -- Bound
				drawfilledRect(TownCenter[i].X + 20, TownCenter[i].Y - 10, TownCenter[i].MaxHP / 16, 2, Red)
				drawfilledRect(TownCenter[i].X + 20, TownCenter[i].Y - 10, TownCenter[i].HP / 16, 2, Green)
			end
			screen:blit(TownCenter[i].X, TownCenter[i].Y, TownCenter[i].IMG, true)
		end
	end
	
	for i = 1, 8 do
		if House[i].Builded == true then
			if House[i].Selected == true then
				screen:blit(House[i].X - 22, House[i].Y + 8, spr.build.Select.S2x2) -- Bound
				drawfilledRect(House[i].X + 20, House[i].Y - 10, House[i].MaxHP / 10, 2, Red)
				drawfilledRect(House[i].X + 20, House[i].Y - 10, House[i].HP / 10, 2, Green)
			end
			screen:blit(House[i].X, House[i].Y, House[i].IMG, true)
		end
	end
	
	if null[1].Exists == true then
		screen:blit(null[1].X, null[1].Y, null[1].IMG)
	end
	
	for i = 1, 8 do
		-- Optimized
		if Berry[i].Exists == true and Berry[i].Food ~= 0 and Berry[i].X + Info.Berry.Width >= 0 and Berry[i].X <= 480 and Berry[i].Y + Info.Berry.Height >= 0 and Berry[i].Y <= 272 then
			if Berry[i].Selected == true then
				screen:blit(Berry[i].X - 10, Berry[i].Y - Info.Berry.Height / 2 + 22, spr.build.Select.S1x1) -- Bound
			end
			screen:blit(Berry[i].X, Berry[i].Y, Berry[i].IMG, true)
		end
		--if Berry[i].Food <= 0 then
		--	Berry[i].Exists = false
		--end
		
		-- Optimized
		if Tree[i].Exists == true and Tree[i].Wood ~= 0 and Tree[i].X + Info.Tree.Width >= 0 and Tree[i].X <= 480 and Tree[i].Y + Info.Tree.Height >= 0 and Tree[i].Y <= 272 then
			if Tree[i].Selected == true then
				screen:blit(Tree[i].X + 8, Tree[i].Y + Info.Tree.Height / 2 + 15, spr.build.Select.S1x1) -- Bound
			end
			screen:blit(Tree[i].X, Tree[i].Y, Tree[i].IMG)
		end
		-- Optimized
		if Gold[i].Exists == true and Gold[i].Gold ~= 0 and Gold[i].X + Info.Gold.Width >= 0 and Gold[i].X <= 480 and Gold[i].Y + Info.Gold.Height >= 0 and Gold[i].Y <= 272 then
			if Gold[i].Selected == true then
				screen:blit(Gold[i].X - 8, Gold[i].Y - Info.Gold.Height / 2 + 18, spr.build.Select.S1x1) -- Bound
			end
			screen:blit(Gold[i].X, Gold[i].Y, Gold[i].IMG, true)
		end
		-- Optimized
		if Stone[i].Exists == true and Stone[i].Stone ~= 0 and Stone[i].X + Info.Stone.Width >= 0 and Stone[i].X <= 480 and Stone[i].Y + Info.Stone.Height >= 0 and Stone[i].Y <= 272 then
			if Stone[i].Selected == true then
				screen:blit(Stone[i].X - 10, Stone[i].Y - Info.Stone.Height / 2 + 12, spr.build.Select.S1x1) -- Bound
			end
			screen:blit(Stone[i].X, Stone[i].Y, Stone[i].IMG, true)
		end
	end
	
	for i = 1, 8 do
		if Villager[i].Exists == true then
			if Villager[i].Selected == true then
				screen:blit(Villager[i].X - 7, Villager[i].Y + 30, spr.uni.Select.Small) -- Bound
				drawfilledRect(Villager[i].X - 2, Villager[i].Y - 10, Villager[i].MaxHP / 2, 2, Red)
				drawfilledRect(Villager[i].X - 2, Villager[i].Y - 10, Villager[i].HP / 2, 2, Green)
			end
			--screen:blit(Villager[i].X - Info.Villager.Width / 2, Villager[i].Y - Info.Villager.Height / 2, Villager[i].IMG)
			screen:blit(Villager[i].X, Villager[i].Y, Villager[i].IMG)
		end
	end
	for i = 1, 8 do
		if Militia[i].Exists == true then
			if Militia[i].Selected == true then
				screen:blit(Militia[i].X - 7, Militia[i].Y + 30, spr.uni.Select.Small) -- Bound
				drawfilledRect(Militia[i].X - 2, Militia[i].Y - 10, Militia[i].MaxHP / 2, 2, Red)
				drawfilledRect(Militia[i].X - 2, Militia[i].Y - 10, Militia[i].HP / 2, 2, Green)
			end
			--screen:blit(Militia[i].X - Info.Militia.Width / 2, Militia[i].Y - Info.Militia.Height / 2, Militia[i].IMG)
			screen:blit(Militia[i].X, Militia[i].Y, Militia[i].IMG)
		end
	end

	--PopulationCheck()
	
	-- GUI Rendering
	screen:blit(0, 0,spr.assets.GamePanel, true)
	
	screen:blit(338,200,spr.assets.MiniMap) -- 330, 197  or  338, 200
	screen:fontPrint(Arial,288,13,Global.Player.Pop.."/"..Global.Player.MaxPop,white)
	screen:fontPrint(Arial,27,13,Global.Player.Wood,white)
	screen:fontPrint(Arial,94,13,Global.Player.Food,white)
	screen:fontPrint(Arial,160,13,Global.Player.Gold,white)
	screen:fontPrint(Arial,220,13,Global.Player.Stone,white)
	
	screen:fontPrint(Arial,380-1,13-1,Global.Player.Age,black)
	screen:fontPrint(Arial,380,13,Global.Player.Age,white)
	
	screen:fontPrint(Arial,385-1,190-1,Global.Player.Nick.." (0/0)",black)
	screen:fontPrint(Arial,385,190,Global.Player.Nick.." (0/0)",Global.Player.NickCol)
	
	-- Debug Mode
	
	if tick >= 60 then tick = 0 end
	
	tick = tick + 1
	
	screen:fontPrint(Arial,10-1,35-1,"Tick: "..tick,Black)
	screen:fontPrint(Arial,10,35,"Tick: "..tick,White)
	
	if WindTimer >= 0 then
		WindTimer = WindTimer + 1
	end
	
	--screen:fontPrint(Arial,10-1,45-1,"Timer: "..WindTimer,Black)
	--screen:fontPrint(Arial,10,45,"Timer: "..WindTimer,White)
	
	if WindTimer == 200 then
		Mp3me.stop()
		Mp3me.load("Sounds/Wind1.mp3")
		Mp3me.play()
	elseif WindTimer == 700 then
		Mp3me.stop()
		Mp3me.load("Sounds/Wind2.mp3")
		Mp3me.play()
	elseif WindTimer == 1000 then
		Mp3me.stop()
		Mp3me.load("Sounds/Wind3.mp3")
		Mp3me.play()
	end
	
	if WindTimer >= 1001 or WindTimer <= -1 then WindTimer = 0 end
	
	--[[
	
	x = 10
	y = 35
	
	for i = 1, lim do
		if Villager[i].Selected == true then
			screen:fontPrint(Arial,x,y,"Vil["..i.."].Sel = true",white)
		end
		if Villager[i].Selected == false then
			screen:fontPrint(Arial,x,y,"Vil["..i.."].Sel = false",white)
		end
		y = y + 15
	end
	
	x = 110
	y = 35
	
	for i = 1, lim do
		if Villager[i].Follow == true then
			screen:fontPrint(Arial,x,y,"Vil["..i.."].Fol = true",white)
		end
		if Villager[i].Follow == false then
			screen:fontPrint(Arial,x,y,"Vil["..i.."].Fol = false",white)
		end
		y = y + 15
	end
	
	
	x = 200
	y = 35
	
	for i = 1, lim do
		screen:fontPrint(Arial,x,y,"Vil["..i.."].TarX = "..Villager[i].TarX,white)
		y = y + 15
	end
	
	x = 320
	y = 35
	
	for i = 1, lim do
		screen:fontPrint(Arial,x,y,"Vil["..i.."].TarY = "..Villager[i].TarY,white)
		y = y + 15
	end
	
	--]]
	
	--screen:fontPrint(Arial,380,175,null[1].X.." ".. null[1].Y,white)

	for i = 1, 8 do
		if Villager[i].Selected == true then
			screen:fontPrint(Arial,140,218,"Villager ["..i.."]",black)
			screen:fontPrint(Arial,200,235,Global.Player.Nick,black)
			screen:fontPrint(Arial,200,245,Global.Player.Civ,black)
			screen:fontPrint(Arial,140,210 + 30 + 15 + 10,Villager[i].HP.."/"..Villager[i].MaxHP,black)
			if Villager[i].Type == 1 then
				screen:blit(140,220,spr.uni.VillagerMale.Icon)
			elseif Villager[i].Type == 2 then
				screen:blit(140,220,spr.uni.VillagerFemale.Icon)
			end
			drawfilledRect(140, 250, Villager[i].MaxHP / 2, 2, Red)
			drawfilledRect(140, 250, Villager[i].HP / 2, 2, Green)
			if Villager[i].Food ~= 0 then
				screen:blit(260,220,spr.assets.ico.Food) -- 25x15
				screen:fontPrint(Arial,250,220+15+15,Villager[i].Food.."/"..Global.Player.Villager.MaxInv,black)
				Villager[i].Wood = 0
				Villager[i].Gold = 0
				Villager[i].Stone = 0
			end
		end
		--[[
		if Villager[i].Target == Berry[i] or Villager[i].Target == Tree[i] or Villager[i].Target == Gold[i] or Villager[i].Target == Stone[i] then
			-- i need to do something here, but i forgot...
			if pad:triangle() then
				Villager[i].Target = nil
				Villager[i].LastTarget = nil
			end
		end
		if Villager[i].Target == Berry[i] and Villager[i].Food <= Global.Player.Villager.MaxInv then
			Villager[i].LastTarget = Berry[i]
			Villager[i].Food = Villager[i].Food + 1
			Berry[i].Food = Berry[i].Food - 1
		end
		if Villager[i].Target == Tree[i] and Villager[i].Tree <= Global.Player.Villager.MaxInv then
			Villager[i].LastTarget = Tree[i]
			Villager[i].Wood = Villager[i].Wood + 1
			Tree[i].Wood = Tree[i].Wood - 1
		end
		--]]
	end
	for i = 1, 8 do
		if Militia[i].Selected == true then
			screen:fontPrint(Arial,140,218,"Militia ["..i.."]",black)
			screen:fontPrint(Arial,200,235,Global.Player.Nick,black)
			screen:fontPrint(Arial,200,245,Global.Player.Civ,black)
			screen:fontPrint(Arial,140,210 + 30 + 15 + 10,Militia[i].HP.."/"..Militia[i].MaxHP,black)
			screen:blit(140,220,spr.uni.Militia.Icon)
			drawfilledRect(140, 250, Militia[i].MaxHP / 2, 2, Red)
			drawfilledRect(140, 250, Militia[i].HP / 2, 2, Green)
		end
	end
	
	for i = 1, 8 do
		if Berry[i].Selected == true then
			screen:blit(140,220,spr.res.Food.Icon)
			screen:fontPrint(Arial,140,218,"Forage Bush ["..i.."]",black)
			screen:blit(270,220,spr.assets.ico.Food) -- 25x15
			screen:fontPrint(Arial,260,220+15+5+5,Berry[i].Food.."/"..Berry[i].MaxFood,black)
		end
		if Tree[i].Selected == true then
			screen:blit(140,220,spr.res.Tree.Icon)
			screen:fontPrint(Arial,140,218,"Tree ["..i.."]",black)
			screen:blit(270,220,spr.assets.ico.Wood)
			screen:fontPrint(Arial,260,220+15+5+5,Tree[i].Wood.."/"..Tree[i].MaxWood,black)
		end
		if Gold[i].Selected == true then
			screen:blit(140,220,spr.res.Gold.Icon)
			screen:fontPrint(Arial,140,218,"Gold Mine ["..i.."]",black)
			screen:blit(270,220,spr.assets.ico.Gold)
			screen:fontPrint(Arial,260,220+15+5+5,Gold[i].Gold.."/"..Gold[i].MaxGold,black)
		end
		if Stone[i].Selected == true then
			screen:blit(140,220,spr.res.Stone.Icon)
			screen:fontPrint(Arial,140,218,"Stone Mine ["..i.."]",black)
			screen:blit(270,220,spr.assets.ico.Stone)
			screen:fontPrint(Arial,260,220+15+5+5,Stone[i].Stone.."/"..Stone[i].MaxStone,black)
		end
	end
	
	--[[
	for i = 1, 8 do
		if Villager[i].Exists == true then
			if Villager[i].Selected == true then
				screen:blit(140,220,spr.uni.VillagerMale.Icon)
				if Villager[i+1].Selected == true then
					screen:blit(140+40,220,spr.uni.VillagerMale.Icon)
					if Villager[i+2].Selected == true then
						screen:blit(140+40+40,220,spr.uni.VillagerMale.Icon)
						if Villager[i+3].Selected == true then
							screen:blit(140+40+40+40,220,spr.uni.VillagerMale.Icon)
						end
					end
				end
			end
		end
	end
	--]]
	
	for i = 1, 8 do
		if TownCenter[i].Builded == true then
			if TownCenter[i].Selected == true then
				screen:fontPrint(Arial,185,225,"Town Center",black)
				screen:fontPrint(Arial,185,235,Global.Player.Nick,black)
				screen:fontPrint(Arial,185,245,Global.Player.Civ,black)
				screen:blit(140,215,spr.build.TC.Icon)
			end
		end
	end
	
	for i = 1, 8 do
		if House[i].Builded == true then
			if House[i].Selected == true then
				screen:fontPrint(Arial,185,225,"House",black)
				screen:fontPrint(Arial,185,235,Global.Player.Nick,black)
				screen:fontPrint(Arial,185,245,Global.Player.Civ,black)
				screen:blit(140,215,spr.build.House.Icon)
			end
		end
	end
	
	for i = 1, 8 do
		if Villager[i].Selected == true and Cursor.Under == Berry[i] or Cursor.Under == Tree[i] or Cursor.Under == Gold[i] or Cursor.Under == Stone[i] then
			screen:blit(Cursor.X, Cursor.Y, Cursor.IMG_RES)
		else
			screen:blit(Cursor.X, Cursor.Y, Cursor.IMG_DEF)
		end
	end
	
	if mState == "Save" then -----------------------------------------------------------------------------------------
		
		screen:blit(51,22,PanelBG)
		
		screen:fontPrint(Arial,210,50,"Save Menu",Black)
		screen:fontPrint(Arial,190,80,"Save Config as Map 1",MapColor.Map1)
		screen:fontPrint(Arial,190,100,"Save Config as Map 2",MapColor.Map2)
		screen:fontPrint(Arial,190,120,"Save Config as Map 3",MapColor.Map3)
		
		if SaveIndex == 1 then
			MapColor.Map1 = Color.new(255,255,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 2 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(255,255,0)
			MapColor.Map3 = Color.new(0,0,0)
		end
		if SaveIndex == 3 then
			MapColor.Map1 = Color.new(0,0,0)
			MapColor.Map2 = Color.new(0,0,0)
			MapColor.Map3 = Color.new(255,255,0)
		end
		
		if SaveIndex >= 4 then SaveIndex = 3 end
		if SaveIndex <= 0 then SaveIndex = 1 end
		
		if pad:down() then SaveIndex = SaveIndex + 1 end
		if pad:up() then SaveIndex = SaveIndex - 1 end
		
		if pad:cross() then
			if SaveIndex == 1 then
				SaveGame("Map1", "Saved Game", "", "", "Normal", "None", MV, Update)
				--SaveConfig("Map 1")
			end
			if SaveIndex == 2 then
				SaveGame("Map2", "Saved Game", "", "", "Normal", "None", MV, Update)
			end
			if SaveIndex == 3 then
				SaveGame("Map3", "Saved Game", "", "", "Normal", "None", MV, Update)
			end
		end
		
		if pad:circle() then
			if pressed.circle == false then
				pressed.circle = true
				mState = "Menu"
			end
		else
			pressed.circle = false
		end
		
	end -----------------------------------------------------------------------------------------
	
	if mState == "Options" then -----------------------------------------------------------------------------------------
		
		screen:blit(51,22,OptionsBG)

		if pad:circle() then
			if pressed.circle == false then
				pressed.circle = true
				mState = "Menu"
			end
		else
			pressed.circle = false
		end
		
	end -- mState Options -----------------------------------------------------------------------------------------
	
	if mState == "Menu" then
		screen:blit(136,7,GameMenu)
		screen:fontPrint(Arial,203,32,"Game Paused",black)
		
		-- i won't use "for", don't ask...
		
		-- Menu Parts Blit
		screen:blit(160,42,EmptyButton) -- Resume Game
		screen:fontPrint(Arial,202,58,"Resume Game",ButtonColor.ResumeGame)
		
		screen:blit(160,74,EmptyButton) -- Options
		screen:fontPrint(Arial,218,90,"Options",ButtonColor.Options)
		
		screen:blit(160,106,EmptyButton) -- Controls
		screen:fontPrint(Arial,216,122,"Controls",ButtonColor.Controls)
		
		screen:blit(160,138,EmptyButton) -- Save
		screen:fontPrint(Arial,224,153,"Save",ButtonColor.Save)
		
		screen:blit(160,170,EmptyButton) -- Exit and Save
		screen:fontPrint(Arial,202,186,"Exit And Save",ButtonColor.ExitSave)
		
		screen:blit(160,203,EmptyButton) -- Exit
		screen:fontPrint(Arial,227,220,"Exit",ButtonColor.Exit)
		
		-- Moving
		if pad:down() then
			if pressed.down == false then
				pressed.down = true
				CurButton = CurButton + 1
			end
		else
			pressed.down = false
		end
		
		if pad:up() then
			if pressed.up == false then
				pressed.up = true
				CurButton = CurButton - 1
			end
		else
			pressed.up = false
		end
		
		if pad:cross() and CurButton == 1 then mState = "Game" end if pad:start() then mState = "Game" end -- Resume Game
		if pad:cross() and CurButton == 2 then mState = "Options" end -- Options
		if pad:cross() and CurButton == 3 then  end -- Controls
		if pad:cross() and CurButton == 4 then mState = "Save" end -- Save
		if pad:cross() and CurButton == 5 then  end -- Exit and Save
		if pad:cross() and CurButton == 6 then
			dofile("MainMenu.lua")
			break
		end -- Exit
		
		if CurButton > 6 then CurButton = 1 end
		if CurButton < 1 then CurButton = 6 end
		
		if CurButton == 1 then
			ButtonColor.ResumeGame = Color.new(255,255,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 2 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(255,255,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 3 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(255,255,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 4 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(255,255,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 5 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(255,255,0)
			ButtonColor.Exit = Color.new(0,0,0)
		end
		
		if CurButton == 6 then
			ButtonColor.ResumeGame = Color.new(0,0,0)
			ButtonColor.Options = Color.new(0,0,0)
			ButtonColor.Controls = Color.new(0,0,0)
			ButtonColor.Save = Color.new(0,0,0)
			ButtonColor.ExitSave = Color.new(0,0,0)
			ButtonColor.Exit = Color.new(255,255,0)
		end

	end
	
	if mState == "Game" then ---------------------------------------------------------------------------------------------------------

		--ANALOG-X
		dx = pad:analogX()
		if math.abs(dx) > 32 then
			Cursor.X = Cursor.X + dx / 20
		end
		--ANALOG-Y
		dy = pad:analogY()
		if math.abs(dy) > 32 then
			Cursor.Y = Cursor.Y + dy / 20
		end
		--DPAD
		
		-- Moving all items --
		
		if pad:square() then
			-- Y + -------------------------------------------------
			if pad:up() then
				for i = 1,4 do
					BackY[i] = BackY[i] + Cursor.Speed
				end
				for i = 1, 8 do
					if TownCenter[i].Builded == true then TownCenter[i].Y = TownCenter[i].Y + Cursor.Speed end
					if House[i].Builded == true then House[i].Y = House[i].Y + Cursor.Speed end
					if Villager[i].Exists == true then
						Villager[i].Y = Villager[i].Y + Cursor.Speed
						Villager[i].TarY = Villager[i].TarY + Cursor.Speed
					end
					if Militia[i].Exists == true then
						Militia[i].Y = Militia[i].Y + Cursor.Speed
						Militia[i].TarY = Militia[i].TarY + Cursor.Speed
					end
					if Berry[i].Exists == true then Berry[i].Y = Berry[i].Y + Cursor.Speed end
					if Tree[i].Exists == true then Tree[i].Y = Tree[i].Y + Cursor.Speed end
					if Gold[i].Exists == true then Gold[i].Y = Gold[i].Y + Cursor.Speed end
					if Stone[i].Exists == true then Stone[i].Y = Stone[i].Y + Cursor.Speed end
				end
				null[1].Y = null[1].Y + Cursor.Speed
				Mineral[1].Y = Mineral[1].Y + Cursor.Speed
				Cursor.LastY = Cursor.LastY + Cursor.Speed
			end
			
			-- Y - --------------------------------------------------
			if pad:down() then
				for i = 1,4 do
					BackY[i] = BackY[i] - Cursor.Speed
				end
				for i = 1, 8 do
					if TownCenter[i].Builded == true then TownCenter[i].Y = TownCenter[i].Y - Cursor.Speed end
					if House[i].Builded == true then House[i].Y = House[i].Y - Cursor.Speed end
					if Villager[i].Exists == true then
						Villager[i].Y = Villager[i].Y - Cursor.Speed
						Villager[i].TarY = Villager[i].TarY - Cursor.Speed
					end
					if Militia[i].Exists == true then
						Militia[i].Y = Militia[i].Y - Cursor.Speed
						Militia[i].TarY = Militia[i].TarY - Cursor.Speed
					end
					if Berry[i].Exists == true then Berry[i].Y = Berry[i].Y - Cursor.Speed end
					if Tree[i].Exists == true then Tree[i].Y = Tree[i].Y - Cursor.Speed end
					if Gold[i].Exists == true then Gold[i].Y = Gold[i].Y - Cursor.Speed end
					if Stone[i].Exists == true then Stone[i].Y = Stone[i].Y - Cursor.Speed end
				end
				null[1].Y = null[1].Y - Cursor.Speed
				Mineral[1].Y = Mineral[1].Y - Cursor.Speed
				Cursor.LastY = Cursor.LastY - Cursor.Speed
			end
			 
			-- X + -----------------------------------------------------
			if pad:left() then
				for i = 1,4 do
					BackX[i] = BackX[i] + Cursor.Speed
				end
				for i = 1, 8 do
					if TownCenter[i].Builded == true then TownCenter[i].X = TownCenter[i].X + Cursor.Speed end
					if House[i].Builded == true then House[i].X = House[i].X + Cursor.Speed end
					if Villager[i].Exists == true then
						Villager[i].X = Villager[i].X + Cursor.Speed
						Villager[i].TarX = Villager[i].TarX + Cursor.Speed
					end
					if Militia[i].Exists == true then
						Militia[i].X = Militia[i].X + Cursor.Speed
						Militia[i].TarX = Militia[i].TarX + Cursor.Speed
					end
					if Berry[i].Exists == true then Berry[i].X = Berry[i].X + Cursor.Speed end
					if Tree[i].Exists == true then Tree[i].X = Tree[i].X + Cursor.Speed end
					if Gold[i].Exists == true then Gold[i].X = Gold[i].X + Cursor.Speed end
					if Stone[i].Exists == true then Stone[i].X = Stone[i].X + Cursor.Speed end
				end
				null[1].X = null[1].X + Cursor.Speed
				Mineral[1].X = Mineral[1].X + Cursor.Speed
				Cursor.LastX = Cursor.LastX + Cursor.Speed
			end
			
			-- X - -------------------------------------------------------
			if pad:right() then
				for i = 1,4 do
					BackX[i] = BackX[i] - Cursor.Speed
				end
				for i = 1, 8 do
					if TownCenter[i].Builded == true then TownCenter[i].X = TownCenter[i].X - Cursor.Speed end
					if House[i].Builded == true then House[i].X = House[i].X - Cursor.Speed end
					if Villager[i].Exists == true then
						Villager[i].X = Villager[i].X - Cursor.Speed
						Villager[i].TarX = Villager[i].TarX - Cursor.Speed
					end
					if Militia[i].Exists == true then
						Militia[i].X = Militia[i].X - Cursor.Speed
						Militia[i].TarX = Militia[i].TarX - Cursor.Speed
					end
					if Berry[i].Exists == true then Berry[i].X = Berry[i].X - Cursor.Speed end
					if Tree[i].Exists == true then Tree[i].X = Tree[i].X - Cursor.Speed end
					if Gold[i].Exists == true then Gold[i].X = Gold[i].X - Cursor.Speed end
					if Stone[i].Exists == true then Stone[i].X = Stone[i].X - Cursor.Speed end
				end
				null[1].X = null[1].X - Cursor.Speed
				Mineral[1].X = Mineral[1].X - Cursor.Speed
				Cursor.LastX = Cursor.LastX - Cursor.Speed
			end
		end
	
	if pad:circle() then
		UnSelectBuildings("for")
		UnSelectUnits("for")
		UnSelectResources("for")
	end
	
	
	--[[
	if start >= 1 then
		bonkSound:play()
		Music.volume(20)
		start = 0
	end
	--]]
	
	-- Control Background motion
	for i = 1,4 do
		if BackY[i] >= 272 then BackY[i] = -272 end
		if BackX[i] > 480 then BackX[i] = -480 end
		if BackY[i] <= -273 then BackY[i] = 272 end
		if BackX[i] < -480 then BackX[i] = 480  end
	end
	
	--boundaries
	if Cursor.X >= 480 then Cursor.X = 480 end
	if Cursor.X <= 0 then Cursor.X = 0 end
	if Cursor.Y <= 0 then Cursor.Y = 0 end
	if Cursor.Y >= 252 then Cursor.Y = 252 end
	
	
	
	
	-- Selecting Objects
	if Cursor.Y > 20 and Cursor.Y < 200 and pad:cross() then
		if pressed.cross == true then
			pressed.cross = false
			Cursor.LastX = Cursor.X
			Cursor.LastY = Cursor.Y
			
			for i = 1, 8 do -- Select
				
				
				if TownCenter[i].Builded == true then
					if Cursor.LastX >= TownCenter[i].X and Cursor.LastX <= TownCenter[i].X + Info.TC.Width and Cursor.LastY >= TownCenter[i].Y and Cursor.LastY <= TownCenter[i].Y + Info.TC.Height and pad:cross() then
						Mp3me.stop()
						Mp3me.load("Sounds/towncenter.mp3")
						Mp3me.play()
						UnSelectResources("Classic")
						UnSelectBuildings("Classic")
						UnSelectUnits("Classic")
						TownCenter[i].Selected = true
					end
				end
				if House[i].Builded == true then
					if Cursor.LastX >= House[i].X and Cursor.LastX <= House[i].X + Info.House.Width and Cursor.LastY >= House[i].Y and Cursor.LastY <= House[i].Y + Info.House.Height and pad:cross() then
						Mp3me.stop()
						Mp3me.load("Sounds/house.mp3")
						Mp3me.play()
						UnSelectResources("Classic")
						UnSelectBuildings("Classic")
						UnSelectUnits("Classic")
						House[i].Selected = true
					end
				end
				
				if Villager[i].Exists == true then
					if Cursor.LastX >= Villager[i].X and Cursor.LastX <= Villager[i].X + Info.Villager.Width and Cursor.LastY >= Villager[i].Y and Cursor.LastY <= Villager[i].Y + Info.Villager.Height then
						if Villager[i].Selected == true then
							Villager[i].Selected = false
						else
							UnSelectResources("Classic")
							UnSelectBuildings("Classic")
							UnSelectUnits("Classic")
							Villager[i].Selected = true
						end
					end
				end
				if Militia[i].Exists == true then
					if Cursor.LastX >= Militia[i].X and Cursor.LastX <= Militia[i].X + Info.Militia.Width and Cursor.LastY >= Militia[i].Y and Cursor.LastY <= Militia[i].Y + Info.Militia.Height then
						if Militia[i].Selected == true then
							Militia[i].Selected = false
						else
							UnSelectResources("Classic")
							UnSelectBuildings("Classic")
							UnSelectUnits("Classic")
							Militia[i].Selected = true
						end
					end
				end
				if Berry[i].Exists == true then
					if Cursor.LastX >= Berry[i].X and Cursor.LastX <= Berry[i].X + Info.Berry.Width and Cursor.LastY >= Berry[i].Y and Cursor.LastY <= Berry[i].Y + Info.Berry.Height then
						UnSelectResources("Classic")
						UnSelectBuildings("Classic")
						UnSelectUnits("Classic")
						Berry[i].Selected = true
					end
					if Cursor.X >= Berry[i].X and Cursor.X <= Berry[i].X + Info.Berry.Width and Cursor.Y >= Berry[i].Y and Cursor.Y <= Berry[i].Y + Info.Berry.Height and Villager[i].Selected == true then
						Cursor.Under = Berry[i]
					end
				end
				if Tree[i].Exists == true then
					if Cursor.LastX >= Tree[i].X and Cursor.LastX <= Tree[i].X + Info.Tree.Width and Cursor.LastY >= Tree[i].Y and Cursor.LastY <= Tree[i].Y + Info.Tree.Height then
						UnSelectResources("Classic")
						UnSelectBuildings("Classic")
						UnSelectUnits("Classic")
						Tree[i].Selected = true
					end
					if Cursor.X >= Tree[i].X and Cursor.X <= Tree[i].X + Info.Tree.Width and Cursor.Y >= Tree[i].Y and Cursor.Y <= Tree[i].Y + Info.Tree.Height and Villager[i].Selected == true then
						Cursor.Under = Tree[i]
					end
				end
				if Gold[i].Exists == true then
					if Cursor.LastX >= Gold[i].X and Cursor.LastX <= Gold[i].X + Info.Gold.Width and Cursor.LastY >= Gold[i].Y and Cursor.LastY <= Gold[i].Y + Info.Gold.Height then
						UnSelectResources("Classic")
						UnSelectBuildings("Classic")
						UnSelectUnits("Classic")
						Gold[i].Selected = true
					end
					if Cursor.X >= Gold[i].X and Cursor.X <= Gold[i].X + Info.Gold.Width and Cursor.Y >= Tree[i].Y and Cursor.Y <= Gold[i].Y + Info.Gold.Height and Villager[i].Selected == true then
						Cursor.Under = Gold[i]
					end
				end
				if Stone[i].Exists == true then
					if Cursor.LastX >= Stone[i].X and Cursor.LastX <= Stone[i].X + Info.Stone.Width and Cursor.LastY >= Stone[i].Y and Cursor.LastY <= Stone[i].Y + Info.Stone.Height then
						UnSelectResources("Classic")
						UnSelectBuildings("Classic")
						UnSelectUnits("Classic")
						Stone[i].Selected = true
					end
					if Cursor.X >= Stone[i].X and Cursor.X <= Stone[i].X + Info.Stone.Width and Cursor.Y >= Stone[i].Y and Cursor.Y <= Stone[i].Y + Info.Stone.Height and Villager[i].Selected == true then
						Cursor.Under = Stone[i]
					end
				end
				
				
			end -- for end
			
			for i = 1, 8 do
				if Villager[i].Selected == true then
					Villager[i].Follow = true
					Villager[i].TarX = Cursor.LastX
					Villager[i].TarY = Cursor.LastY
				end
				if Militia[i].Selected == true then
					Militia[i].Follow = true
					Militia[i].TarX = Cursor.LastX
					Militia[i].TarY = Cursor.LastY
				end
			end
			
		else
			pressed.cross = true
		end
	end -- End of selecting objects
	
	-- Animation and Walking
	for i = 1, 8 do
		
		if Militia[i].Exists == true then
			if Militia[i].X == Militia[i].TarX and Militia[i].Y == Militia[i].TarY then
				Militia[i].Follow = false
			end
			if Militia[i].Follow == true then
				if Militia[i].TarX ~= Militia[i].X and Militia[i].TarY ~= Militia[i].Y then
				
				
				
					--if Militia[i].X + Info.Militia.Width >= TownCenter[i].X or House[i].X then -- Collision to Right
					--	Militia[i].X = Militia[i].X - 1
					--else
						if Militia[i].TarX >= Militia[i].X then
							Militia[i].X = Militia[i].X + Militia[i].Speed
						end
					--end
					--if Militia[i].X <= TownCenter[i].X + Info.TC.Width or House[i].X + Info.House.Width then -- Collision to Left
					--	Militia[i].X = Militia[i].X + 1
					--else
						if Militia[i].TarX <= Militia[i].X then
							Militia[i].X = Militia[i].X - Militia[i].Speed
						end
					--end
					--if Militia[i].Y + Info.Militia.Height >= TownCenter[i].Y or House[i].Y then -- Collision to Down
					--	Militia[i].Y = Militia[i].Y - 1
					--else
						if Militia[i].TarY >= Militia[i].Y then
							Militia[i].Y = Militia[i].Y + Militia[i].Speed
						end
					--end
					--if Militia[i].Y <= TownCenter[i].Y + Info.TC.Height or House[i].Y + Info.House.Height then -- Collision to Up
					--	Militia[i].Y = Militia[i].Y + 1
					--else
						if Militia[i].TarY <= Militia[i].Y then
							Militia[i].Y = Militia[i].Y - Militia[i].Speed
						end
					--end
					
					
					
					
				end
				
			end
			
			if Militia[i].TarY < Militia[i].Y and Militia[i].TarX == Militia[i].X then
				Militia[i].IMG = spr.uni.Militia.Up
			end
			if Militia[i].TarY > Militia[i].Y and Militia[i].TarX == Militia[i].X then
				Militia[i].IMG = spr.uni.Militia.Down
			end
			if Militia[i].TarX < Militia[i].X and Militia[i].TarY == Militia[i].Y then
				Militia[i].IMG = spr.uni.Militia.Left
			end
			if Militia[i].TarX > Militia[i].X and Militia[i].TarY == Militia[i].Y then
				Militia[i].IMG = spr.uni.Militia.Right
			end
			if Militia[i].TarY < Militia[i].Y and Militia[i].TarX < Militia[i].X then
				Militia[i].IMG = spr.uni.Militia.UpLeft
			end
			if Militia[i].TarY > Militia[i].Y and Militia[i].TarX > Militia[i].X then
				Militia[i].IMG = spr.uni.Militia.DownRight
			end
			if Militia[i].TarY > Militia[i].Y and Militia[i].TarX < Militia[i].X then
				Militia[i].IMG = spr.uni.Militia.DownLeft
			end
			if Militia[i].TarY < Militia[i].Y and Militia[i].TarX> Militia[i].X then
				Militia[i].IMG = spr.uni.Militia.UpRight
			end
		end
		
		
		if Villager[i].Exists == true then
			if Villager[i].X == Villager[i].TarX and Villager[i].Y == Villager[i].TarY then
				Villager[i].Follow = false
			end
			if Villager[i].Follow == true then
				if Villager[i].TarX ~= Villager[i].X and Villager[i].TarY ~= Villager[i].Y then
				
				
				
					--if Villager[i].X + Info.Villager.Width >= TownCenter[i].X or House[i].X then -- Collision to Right
					--	Villager[i].X = Villager[i].X - 1
					--else
						if Villager[i].TarX >= Villager[i].X then
							Villager[i].X = Villager[i].X + Villager[i].Speed
							--cfm:play()
						end
					--end
					--if Villager[i].X <= TownCenter[i].X + Info.TC.Width or House[i].X + Info.House.Width then -- Collision to Left
					--	Villager[i].X = Villager[i].X + 1
					--else
						if Villager[i].TarX <= Villager[i].X then
							Villager[i].X = Villager[i].X - Villager[i].Speed
							--cfm:play()
						end
					--end
					--if Villager[i].Y + Info.Villager.Height >= TownCenter[i].Y or House[i].Y then -- Collision to Down
					--	Villager[i].Y = Villager[i].Y - 1
					--else
						if Villager[i].TarY >= Villager[i].Y then
							Villager[i].Y = Villager[i].Y + Villager[i].Speed
							--cfm:play()
						end
					--end
					--if Villager[i].Y <= TownCenter[i].Y + Info.TC.Height or House[i].Y + Info.House.Height then -- Collision to Up
					--	Villager[i].Y = Villager[i].Y + 1
					--else
						if Villager[i].TarY <= Villager[i].Y then
							Villager[i].Y = Villager[i].Y - Villager[i].Speed
							--cfm:play()
						end
					--end
					
					
					
					
				end
				
			end
			
			--[[
			if Villager[i].Target == Berry[i] then
				if Berry[i].X >= Villager[i].X then
					Villager[i].X = Villager[i].X + Villager[i].Speed
				end
				if Berry[i].X <= Villager[i].X then
					Villager[i].X = Villager[i].X - Villager[i].Speed
				end
				if Berry[i].Y >= Villager[i].Y then
					Villager[i].Y = Villager[i].Y + Villager[i].Speed
				end
				if Berry[i].Y <= Villager[i].Y then
					Villager[i].Y = Villager[i].Y - Villager[i].Speed
				end
			end
			if Villager[i].Target == Tree[i] then
				if Tree[i].X >= Villager[i].X then
					Villager[i].X = Villager[i].X + Villager[i].Speed
				end
				if Tree[i].X <= Villager[i].X then
					Villager[i].X = Villager[i].X - Villager[i].Speed
				end
				if Tree[i].Y >= Villager[i].Y then
					Villager[i].Y = Villager[i].Y + Villager[i].Speed
				end
				if Tree[i].Y <= Villager[i].Y then
					Villager[i].Y = Villager[i].Y - Villager[i].Speed
				end
			end
			if Villager[i].Food >= Global.Player.Villager.MaxInv or Villager[i].Wood >= Global.Player.Villager.MaxInv or Villager[i].Gold >= Global.Player.Villager.MaxInv or Villager[i].Stone >= Global.Player.Villager.MaxInv then
				if TownCenter[i].X >= Villager[i].X then
					Villager[i].X = Villager[i].X + Villager[i].Speed
				end
				if TownCenter[i].X <= Villager[i].X then
					Villager[i].X = Villager[i].X - Villager[i].Speed
				end
				if TownCenter[i].Y >= Villager[i].Y then
					Villager[i].Y = Villager[i].Y + Villager[i].Speed
				end
				if TownCenter[i].Y <= Villager[i].Y then
					Villager[i].Y = Villager[i].Y - Villager[i].Speed
				end
				if Villager[i].X - Info.Villager.Width >= TownCenter[i].X and Villager[i].X + Info.Villager.Width <= TownCenter[i].X + Info.TC.Width and Villager[i].Y + Info.Villager.Height >= TownCenter[i].Y and Villager[i].Y + Info.Villager.Height <= TownCenter[i].Y + Info.TC.Height and Villager[i].Food ~= 0 or Villager[i].Wood ~= 0 or Villager[i].Gold ~= 0 or Villager[i].Stone ~= 0 then
					Global.Player.Food = Global.Player.Food + Villager[i].Food
					Global.Player.Food = Global.Player.Food + Villager[i].Wood
					Global.Player.Food = Global.Player.Food + Villager[i].Stone
					Global.Player.Food = Global.Player.Food + Villager[i].Gold
					Villager[i].Food = 0
					Villager[i].Wood = 0
					Villager[i].Stone = 0
					Villager[i].Gold = 0
					Villager[i].Target = Villager[i].LastTarget
				end
			end
			--]]
			
			-- Visuals / Animations
			
			-- Male
			if Villager[i].Type == 1 then
				if Villager[i].TarY < Villager[i].Y and Villager[i].TarX == Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerMale.Up
				end
				if Villager[i].TarY > Villager[i].Y and Villager[i].TarX == Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerMale.Down
				end
				if Villager[i].TarX < Villager[i].X and Villager[i].TarY == Villager[i].Y then
					Villager[i].IMG = spr.uni.VillagerMale.Left
				end
				if Villager[i].TarX > Villager[i].X and Villager[i].TarY == Villager[i].Y then
					Villager[i].IMG = spr.uni.VillagerMale.Right
				end
				if Villager[i].TarY < Villager[i].Y and Villager[i].TarX < Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerMale.UpLeft
				end
				if Villager[i].TarY > Villager[i].Y and Villager[i].TarX > Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerMale.DownRight
				end
				if Villager[i].TarY > Villager[i].Y and Villager[i].TarX < Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerMale.DownLeft
				end
				if Villager[i].TarY < Villager[i].Y and Villager[i].TarX> Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerMale.UpRight
				end
				
				if Villager[i].Target == Berry[i] then
					-- Insert your "Collecting" animation here (-____-)
				end
			end
			
			-- Female
			if Villager[i].Type == 2 then
				if Villager[i].TarY < Villager[i].Y and Villager[i].TarX== Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerFemale.Up
				end
				if Villager[i].TarY > Villager[i].Y and Villager[i].TarX == Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerFemale.Down
				end
				if Villager[i].TarX < Villager[i].X and Villager[i].TarY == Villager[i].Y then
					Villager[i].IMG = spr.uni.VillagerFemale.Left
				end
				if Villager[i].TarX > Villager[i].X and Villager[i].TarY == Villager[i].Y then
					Villager[i].IMG = spr.uni.VillagerFemale.Right
				end
				if Villager[i].TarY < Villager[i].Y and Villager[i].TarX < Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerFemale.UpLeft
				end
				if Villager[i].TarY > Villager[i].Y and Villager[i].TarX > Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerFemale.DownRight
				end
				if Villager[i].TarY> Villager[i].Y and Villager[i].TarX < Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerFemale.DownLeft
				end
				if Villager[i].TarY < Villager[i].Y and Villager[i].TarX > Villager[i].X then
					Villager[i].IMG = spr.uni.VillagerFemale.UpRight
				end
			end
			--[[
			
			Animation
			
			We have a var "Anim.Villager.Type" and more conditions:
			
			
			if Cursor.LastY < Villager[1].Y and Cursor.LastX == Villager[1].X then
				Anim.Villager.Type = "Up"
			end
			if Cursor.LastY > Villager[1].Y and Cursor.LastX == Villager[1].X then
				Anim.Villager.Type = "Down"
			end
			
			
			and then this will check in function "Animation()"
			
			function Animation()
				if Anim.Villager.Type == "Up"
					Row = 2
					screen:blit(X,Y,PIC,x0,y0, x1,y1)
					
					Row 1 - Stand in the all positions
					Row 2 - Walk Up
					Row 3 - Walk Down
					ect...
					
				end
			end
			
			ah, my bad english...
			
			--]]
		end
	end
		
	if pad:select() then
		Screenshot()
	end
	
	--System.getTime() Returns the time from the value entered. Only 1 Time call expected Eg hour = 1,minutes = 2 or seconds = 3 and microseconds = 4 and pm or am = 5.						
	--System.getDate() Returns the date from the value entered. Only 1 Time call expected Eg year = 1,month = 2 or day = 3		
	
	if pad:start() then mState = "Menu" end
	
	end -- mState "Game"'s End
	
	screen.waitVblankStart(1)
	screen.flip()
end